import * as i0 from '@angular/core';
import { Injectable, Directive, SkipSelf, Optional, Pipe, TemplateRef, Input, ContentChild, EventEmitter, forwardRef, Component, Inject, Output, ContentChildren, NgModule } from '@angular/core';
import { of } from 'rxjs';
import * as i7 from '@angular/forms';
import { FormControl, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { debounceTime, flatMap, map } from 'rxjs/operators';
import * as Moment from 'moment';
import Moment__default from 'moment';
import * as i1 from '@angular/material/snack-bar';
import { MatSnackBarModule } from '@angular/material/snack-bar';
import * as i3 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i4 from '@angular/material/tabs';
import { MatTabsModule } from '@angular/material/tabs';
import * as i8 from '@angular/material/autocomplete';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import * as i9 from '@angular/material/core';
import { MatNativeDateModule, MAT_DATE_LOCALE, DateAdapter, MAT_DATE_FORMATS } from '@angular/material/core';
import * as i10 from '@angular/material/form-field';
import { MatFormFieldModule } from '@angular/material/form-field';
import * as i11 from '@angular/material/select';
import { MatSelectModule } from '@angular/material/select';
import * as i12 from '@angular/material/card';
import { MatCardModule } from '@angular/material/card';
import * as i13 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i14 from '@angular/material/tooltip';
import { MatTooltipModule } from '@angular/material/tooltip';
import * as i15 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i16 from '@angular/material/checkbox';
import { MatCheckboxModule } from '@angular/material/checkbox';
import * as i17 from '@angular/material/datepicker';
import { MatDatepickerModule } from '@angular/material/datepicker';
import { MomentDateAdapter, MAT_MOMENT_DATE_FORMATS } from '@angular/material-moment-adapter';
import * as i4$1 from '@angular/material/progress-bar';
import { MatProgressBarModule } from '@angular/material/progress-bar';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';

class StubModel {
    constructor() {
        this.name = 'Stub Model';
        this.id = -1;
    }
    fetchObservable() {
        return of(this);
    }
    saveObservable() {
        return of(this);
    }
    destroyObservable() {
        return of(this);
    }
    toJSON() {
        var v = {};
        Object.keys(this).forEach(k => v[k] = this[k]);
        return v;
    }
    set(a) {
        Object.keys(a).forEach(k => this[k] = a[k]);
        return this;
    }
    file(s) {
        return "not impl";
    }
    rootPath() {
        return 'not impl';
    }
}
class QMapSchema {
    constructor() {
        this.qMapQuestions = [];
        this.questions = [
            {
                type: 'shorttext',
                title: 'Name',
                id: 'name'
            },
            {
                id: 'deriveName',
                type: 'boolean',
                title: 'Derive Name from values?',
                onPos: [
                    {
                        type: 'shorttext',
                        title: 'Derived Name',
                        id: 'derivedName', subititle: 'Handlebars EL'
                    }
                ],
                onNeg: []
            },
            {
                type: 'group',
                title: 'QMAP',
                id: 'qMap',
                style: 'addable',
                items: this.qMapQuestions
            }
        ];
        let rcur = [
            { type: 'qMap',
                items: [
                    {
                        type: 'shorttext',
                        title: 'ID',
                        id: 'id'
                    },
                    {
                        type: 'shorttext',
                        title: 'Title',
                        id: 'title'
                    },
                    {
                        type: 'shorttext',
                        title: 'Sub title',
                        id: 'subtitle'
                    },
                    {
                        type: 'boolean',
                        title: 'Required',
                        id: 'required'
                    },
                    {
                        type: 'choice',
                        title: 'Field Type',
                        id: 'type',
                        style: 'combo',
                        values: [
                            { title: 'Short text', value: 'shorttext', onSelect: [
                                    {
                                        type: 'choice',
                                        title: 'Style',
                                        id: 'style',
                                        style: 'combo',
                                        values: [
                                            { title: 'Email', value: 'email' },
                                            { title: 'Phone', value: 'phone' }
                                        ]
                                    }
                                ] },
                            { title: 'Number', value: 'number', onSelect: [
                                    {
                                        type: 'choice',
                                        title: 'Style',
                                        id: 'style',
                                        style: 'combo',
                                        values: [
                                            { title: 'Decimal', value: 'decimal' },
                                            { title: 'Integer', value: 'integer' }
                                        ]
                                    }
                                ] },
                            { title: 'Checkbox', value: 'boolean' },
                            { title: 'Long text', value: 'text' },
                            { title: 'Date', value: 'date' },
                            { title: 'Date Time', value: 'datetime' },
                            { title: 'Time', value: 'time' },
                            { title: 'Image', value: 'image' },
                            { title: 'Location', value: 'location' },
                            { title: 'File', value: 'file' },
                            { title: 'Grouping', value: 'group',
                                onSelect: [
                                    {
                                        type: 'group',
                                        title: 'Items',
                                        style: 'addable',
                                        id: 'items',
                                        items: this.qMapQuestions
                                    },
                                    {
                                        type: 'choice',
                                        title: 'Style',
                                        id: 'style',
                                        style: 'combo',
                                        values: [
                                            { value: 'addale' },
                                            { value: 'autoadd' }
                                        ]
                                    }
                                ]
                            },
                            { title: 'Object', value: 'object', onSelect: [
                                    {
                                        type: 'shorttext',
                                        title: 'Source Object Type',
                                        id: 'obj_type',
                                        subtitle: 'API Object name, eg User',
                                        required: true
                                    },
                                    {
                                        type: 'json',
                                        title: 'Source Filter',
                                        id: 'filter'
                                    },
                                    {
                                        type: 'choice',
                                        title: 'Style',
                                        id: 'style',
                                        style: 'combo',
                                        values: [
                                            { title: 'Block', value: 'block' },
                                            { title: 'Pulldown', value: 'pulldown' },
                                            { title: 'Inline', value: 'inline' }
                                        ]
                                    }
                                ] },
                            { title: 'Choice', value: 'choice', onSelect: [
                                    {
                                        id: 'useSource',
                                        style: 'buttons',
                                        neg: 'From a List',
                                        pos: 'From Data source',
                                        default: false,
                                        type: 'boolean',
                                        onNeg: [
                                            {
                                                type: 'group',
                                                title: 'Choice Items',
                                                id: 'values',
                                                style: 'addable',
                                                items: [{
                                                        type: 'shorttext',
                                                        title: 'Title (optional)',
                                                        id: 'title'
                                                    }, {
                                                        type: 'shorttext',
                                                        title: 'Value',
                                                        id: 'value',
                                                        required: true
                                                    }]
                                            }
                                        ],
                                        onPos: [
                                            {
                                                type: 'shorttext',
                                                title: 'Source Object Type',
                                                id: 'obj_type', subtitle: 'API Object name, eg User',
                                                required: true
                                            },
                                            {
                                                type: 'json',
                                                title: 'Source Filter',
                                                id: 'filter'
                                            }
                                        ]
                                    },
                                    {
                                        type: 'choice',
                                        title: 'Style',
                                        id: 'style',
                                        style: 'combo',
                                        values: [
                                            { title: 'Combo box', value: 'combo' },
                                            { title: 'Pulldown box', value: 'pulldown' },
                                            { title: 'Buttons', value: 'buttons' }
                                        ]
                                    }
                                ] },
                            { title: 'Columns', value: 'columns', onSelect: [{
                                        type: 'group',
                                        title: 'Col Items',
                                        id: 'items',
                                        style: 'addable',
                                        items: this.qMapQuestions
                                    }
                                ] },
                            { title: 'Tabs', value: 'bunch', onSelect: [
                                    {
                                        type: 'group',
                                        title: 'Tab Group',
                                        style: 'addable',
                                        id: 'items',
                                        items: [
                                            {
                                                type: 'shorttext',
                                                title: 'Tab Name',
                                                id: 'name'
                                            },
                                            {
                                                type: 'group',
                                                title: 'Tab Items',
                                                id: 'items',
                                                style: 'addable',
                                                items: this.qMapQuestions
                                            }
                                        ]
                                    }
                                ] }
                        ]
                    }
                ]
            }
        ];
        rcur.forEach(i => this.qMapQuestions.push(i));
    }
}

class QMAPService {
    constructor() {
        this.posionPill = { id: "Posion Pill" };
    }
    objectTypeQMap(objString) {
        return [{ id: 'name', type: 'shorttext', title: 'Name' }];
    }
    objectsForQMap(qMap, searchString, superModel) {
        console.log('hb');
        return of([]);
    }
    isModel(obj) {
        return !!obj && obj.toJSON;
    }
    findCachedModel(qmap, id) {
        return null;
    }
    makeModel(qmap) {
        return new StubModel();
    }
    canWrite(sm) {
        return true;
    }
    canDelete(sm) {
        return true;
    }
    absURL(sn, fn, stopCache = false) {
        return 'not impl';
    }
    flattenQMAP(qMap) {
        var displayedColumns = [];
        var resolve = (a, qm) => {
            if (typeof a == 'string') {
                return qm[a.substring(1)];
            }
            else
                return a;
        };
        var rcur = (q) => {
            displayedColumns.push(q);
            if (q.items)
                resolve(q.items, q).forEach(qq => rcur(qq));
            if (q.onPos)
                resolve(q.onPos, q).forEach(qq => rcur(qq));
            if (q.onNeg)
                resolve(q.onNeg, q).forEach(qq => rcur(qq));
            if (q.onSelect)
                resolve(q.onSelect, q).forEach(qq => rcur(qq));
            if (q.values)
                q.values.forEach(v => {
                    if (v.onSelect)
                        resolve(v.onSelect, q).forEach(qq => rcur(qq));
                });
        };
        qMap.forEach(q => rcur(q));
        return displayedColumns;
    }
}
/** @nocollapse */ QMAPService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QMAPService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
/** @nocollapse */ QMAPService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QMAPService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QMAPService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class QuestionValidatorDirective {
    constructor(changeDetector, parentValidator) {
        this.changeDetector = changeDetector;
        this.parentValidator = parentValidator;
        this.questions = [];
        this.validQuestions = [];
        this.invalidQuestions = [];
        this.valid = true;
    }
    ngOnInit() {
    }
    ngAfterViewInit() {
        this.changeDetector.detectChanges();
    }
    registerQuestion(q) {
        this.questions.push(q);
        // get around ExpressionChangedAfterItHasBeenCheckedError error
        if (this.parentValidator)
            this.parentValidator.registerQuestion(q);
        else
            this.changeDetector.detectChanges();
    }
    unregisterQuestion(q) {
        this.questions = this.questions.filter(qq => qq != q);
        this.validQuestions = this.validQuestions.filter(qq => qq != q);
        this.invalidQuestions = this.invalidQuestions.filter(qq => qq != q);
        if (this.parentValidator)
            this.parentValidator.unregisterQuestion(q);
        //else
        // get around ExpressionChangedAfterItHasBeenCheckedError error
        //this.changeDetector.detectChanges()
    }
    updateQuestionState(q, valid) {
        this.validQuestions = this.validQuestions.filter(qq => qq != q);
        this.invalidQuestions = this.invalidQuestions.filter(qq => qq != q);
        if (valid)
            this.validQuestions.push(q);
        else
            this.invalidQuestions.push(q);
        this.valid = !this.invalidQuestions.length;
        //this.changeDetector.detectChanges()
        if (this.parentValidator)
            this.parentValidator.updateQuestionState(q, valid);
        //else
        // get around ExpressionChangedAfterItHasBeenCheckedError error
        //this.changeDetector.detectChanges()
    }
}
/** @nocollapse */ QuestionValidatorDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QuestionValidatorDirective, deps: [{ token: i0.ChangeDetectorRef }, { token: QuestionValidatorDirective, optional: true, skipSelf: true }], target: i0.ɵɵFactoryTarget.Directive });
/** @nocollapse */ QuestionValidatorDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.2.9", type: QuestionValidatorDirective, selector: "qmap-validator,[qmap-validator]", exportAs: ["qmap-validator"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QuestionValidatorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'qmap-validator,[qmap-validator]',
                    exportAs: 'qmap-validator'
                }]
        }], ctorParameters: function () {
        return [{ type: i0.ChangeDetectorRef }, { type: QuestionValidatorDirective, decorators: [{
                        type: SkipSelf
                    }, {
                        type: Optional
                    }] }];
    } });

//import * as __ from 'underscore';
//const Moment = _Moment;
/*
const _ = __;

_.templateSettings = {
   interpolate: /\{\{(.+?)\}\}/g,
   evaluate: /\{\%(.+?)\%\}/g
};

String.prototype['qmap_template'] = function(model){
   var template = this
   var json = null
   if(!template || template.indexOf('{{') == -1)
     return template;
    if(model.toJSON){
      json = model.toJSON()
      
    }
    else if(Array.isArray( model )){

    }
    else if(typeof model == 'object'){
      json = {}
      Object.keys(model).forEach((k) => json[k] = model[k])
      
    }

    
    if(json != null){
     
       json.M = Moment
       try{
        return _.template(template)(json)
      }catch(e){
          console.error('TOU EL - ' + e)
         return '!' + template
      }
    }
    else{
      console.error('TOU EL - Model must be an object not')
      return '!!' + template
    }

}
*/
class QFilterPipe {
    transform(items, filter, not) {
        if (!items || !filter) {
            return items;
        }
        if (!Object.keys(filter).length) {
            return items;
        }
        var keyArray = Object.keys(filter);
        // filter items array, items which match and return true will be
        // kept, false will be filtered out
        var fitlerd = items.filter(item => {
            if (not)
                return keyArray.filter(k => item[k] == undefined || !(item[k] == filter[k])).length == keyArray.length;
            else
                return keyArray.filter(k => item[k] == undefined || item[k] == filter[k]).length == keyArray.length;
        });
        return fitlerd;
    }
}
/** @nocollapse */ QFilterPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QFilterPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
/** @nocollapse */ QFilterPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.2.9", ngImport: i0, type: QFilterPipe, name: "qmap_filter", pure: false });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QFilterPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'qmap_filter',
                    pure: false
                }]
        }] });
class QPercentPipe {
    transform(data, format) {
        var s = '' + Math.round(data * 1000) / 10;
        if (s.indexOf('.') == -1)
            return s + ".0";
        else
            return s;
    }
}
/** @nocollapse */ QPercentPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QPercentPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
/** @nocollapse */ QPercentPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.2.9", ngImport: i0, type: QPercentPipe, name: "qmap_percent" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QPercentPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'qmap_percent'
                    // pure: false  // required to update the value when currentLang is changed
                }]
        }] });
class QRoundPipe {
    transform(data, format) {
        var s = '' + Math.round(data * 100) / 100;
        if (s.indexOf('.') == -1)
            return s + ".00";
        else
            return s;
    }
}
/** @nocollapse */ QRoundPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QRoundPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
/** @nocollapse */ QRoundPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.2.9", ngImport: i0, type: QRoundPipe, name: "qmap_round" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QRoundPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'qmap_round'
                    // pure: false  // required to update the value when currentLang is changed
                }]
        }] });
/*

@Pipe({
  name: 'qmap_filter'
 // pure: false  // required to update the value when currentLang is changed
})
export class QFilterPipe implements PipeTransform {

  transform(data: any[], filter: any, exact:boolean = false){
     
     if(!data || !filter || !Object.keys(filter).length)
       return data

     return data.filter(d => Object.keys(filter).find(k => exact?d[k] && d[k] == filter[k]: !d[k] || d[k] == filter[k]))
  }

}
*/
class QMomentPipe {
    transform(data, format, fromNow) {
        if (!data)
            return data;
        var m = Moment__default(data);
        if (format == 'fromNow')
            return m.fromNow();
        return m.format(format || 'YYYY-MMM-DD HH:mm');
    }
}
/** @nocollapse */ QMomentPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QMomentPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
/** @nocollapse */ QMomentPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.2.9", ngImport: i0, type: QMomentPipe, name: "qmap_moment" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QMomentPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'qmap_moment'
                    // pure: false  // required to update the value when currentLang is changed
                }]
        }] });

/************************************************************************************************************************
 * All questions components are placed in this big simple file to avoid circular dependency as is not support in IVY compilation
 ************************************************************************************************************************/
class QMAPTemplate {
}
/** @nocollapse */ QMAPTemplate.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QMAPTemplate, deps: [], target: i0.ɵɵFactoryTarget.Directive });
/** @nocollapse */ QMAPTemplate.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.2.9", type: QMAPTemplate, selector: "qmap-template", inputs: { qMap: ["qMap_id", "qMap"], qType: ["qMap_type", "qType"], qMode: ["mode", "qMode"] }, queries: [{ propertyName: "template", first: true, predicate: TemplateRef, descendants: true, static: true }], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QMAPTemplate, decorators: [{
            type: Directive,
            args: [{
                    selector: 'qmap-template'
                }]
        }], propDecorators: { qMap: [{
                type: Input,
                args: ['qMap_id']
            }], qType: [{
                type: Input,
                args: ['qMap_type']
            }], qMode: [{
                type: Input,
                args: ['mode']
            }], template: [{
                type: ContentChild,
                args: [TemplateRef, { static: true }]
            }] } });
class QuestionComponent {
    set _validator(v) {
        this.validator = v;
    }
    set _template(a) {
        if (a) {
            a.forEach(tt => this.templates.push(tt));
        }
    }
    get val() {
        return this.model ? this.model[this.qMap.id] : null;
    }
    set val(a) {
        this.model[this.qMap.id] = a;
    }
    constructor(tou, snackBar, el, changeDetector, validator) {
        this.tou = tou;
        this.snackBar = snackBar;
        this.el = el;
        this.changeDetector = changeDetector;
        this.validator = validator;
        this.readOnly = false;
        this.outEvent = new EventEmitter();
        this.templates = [];
        this.appearance = "outline";
        this.subs = [];
        this.stopLoop = 0;
    }
    ngOnInit() {
        if (!this.vmodel && (this.tou.isModel(this.model)))
            this.vmodel = this.model;
    }
    ngAfterViewInit() {
        //console.log(this.qMap.id + ' INIT')
        //if(this.qMap.type != 'bunch')
        //	this.initTemplates()
        this.blankModel = !this.model;
        if (!this.model) {
            this.model = this.tou.makeModel(this.qMap);
        }
        if (!this.qMap.id) {
            this.qMap.id = 'generated_' + Math.round(Math.random() * 100000);
        }
        // For type choice in readOnly mode we need to check if it as onSelect to also display the onselect qMap
        if (this.qMap.type == 'choice' && this.readOnly && this.qMap.values && Array.isArray(this.qMap.values)) {
            // Get the qMap for the selected value
            let selectedVal = this.qMap.values.find(obj => obj.value == this.val);
            // Check if selected value has onSelect
            let onSelect = selectedVal ? selectedVal.onSelect : null;
            if (onSelect && typeof onSelect == 'string' && onSelect.startsWith('#')) {
                // get onSelect qMap if reference
                this.onSelectQMap = this.qMap[onSelect.substring(1)];
            }
            else if (onSelect && Array.isArray(onSelect)) {
                this.onSelectQMap = onSelect;
            }
        }
        //if(this.qMap.type == 'bunch')
        this.initTemplates();
        this.changeDetector.detectChanges();
        this._validatorReg();
    }
    ngOnChanges(changes) {
        if (this.needsBcast(changes.qMap || changes.model) && this.widget && this.stopLoop < 10) {
            this.widget.parentChange(changes);
            this.stopLoop++;
        }
        if (this.stopLoop >= 10) {
            console.warn("Stoploop needed to kick inz");
        }
    }
    needsBcast(obj) {
        return obj && ((obj.currentValue && obj.previousValue && obj.currentValue.id != obj.previousValue.id) ||
            (obj.currentValue && !obj.previousValue));
    }
    ngOnDestroy() {
        if (this.validator && this.widget)
            this.validator.unregisterQuestion(this);
    }
    initTemplates() {
        //setTimeout(() => {
        let t = this.templates.find(t => (t.qMode == 'nest') && ((!t.qMap && !t.qType) || t.qMap == this.qMap.id || (t.qType && t.qType == this.qMap.type)));
        if (t)
            this.nestTemplate = t.template;
        t = this.templates.find(t => (t.qMode == 'layout') && ((!t.qMap && !t.qType) || t.qMap == this.qMap.id || (t.qType && t.qType == this.qMap.type)));
        if (t)
            this.layoutTemplate = t.template;
        t = this.templates.find(t => (t.qMode == 'readOnly') && ((!t.qMap && !t.qType) || t.qMap == this.qMap.id || (t.qType && t.qType == this.qMap.type)));
        if (t)
            this.readOnlyTemplate = t.template;
        if (this.parentQuestion) {
            this.validator = this.parentQuestion.validator;
        }
        this.ready = true;
    }
    _validatorReg() {
        if (this.hasRegged)
            return;
        if (this.validator && this.widget) {
            this.validator.registerQuestion(this);
            this.validator.updateQuestionState(this, this.widget.isValid());
            this.hasRegged = true;
        }
    }
    animate() {
        return this.subs.length ? 'child' : 'root';
    }
    updated(value, subQ, child) {
        if (this.autoSave && this.realModel()) {
            this.realModel().saveObservable().subscribe(() => this.snackBar.open('(' + this.model.id + ") " + this.model.name + ' Saved', null, { duration: 500 }), (e) => this.snackBar.open('(' + this.model.id + ') Failed save ', e, { duration: 1500 }));
        }
        if (!this.blankModel || value)
            this.outEvent.emit(value);
    }
    realModel() {
        if (this.parentQuestion)
            return this.parentQuestion.realModel();
        else
            return this.vmodel;
    }
    superModel() {
        if (this.parentQuestion && this.parentQuestion.qMap.type == 'group') {
            var v = this.parentQuestion.superModel();
            // JSON is a copy of the parent of the groups supermodel
            var json = {};
            Object.keys(v).forEach((k) => json[k] = v[k]);
            // plus the active model (for the current group item)
            Object.keys(this.model).forEach((k) => json[k] = this.model[k]);
            // plus a field to indicate the index of this field within its group
            let arry = this.parentQuestion.val;
            if (arry)
                for (var i = 0; i < arry.length; i++) {
                    if (arry[i] == this.model) {
                        json[this.parentQuestion.qMap.id + '_index'] = i;
                        return json;
                    }
                }
            return json;
        }
        else if (this.parentQuestion)
            return this.parentQuestion.superModel();
        else
            return this.model;
    }
    /**
     * Get the iamge / file Uri. used for readOnly mode
     */
    getFileUri() {
        let sm = this.superModel();
        let fn = "";
        if (this.qMap.keepFileName)
            fn = this.model[this.qMap.id + '_filename'];
        else if (this.qMap.filename)
            fn = this.qMap.filename.qmap_template(sm);
        else {
            let extn = this.qMap.extension ? this.qMap.extension.qmap_template(sm) : (this.qMap.type == 'image' ? 'png' : 'bin');
            fn = this.qMap.id + '.' + extn;
            if (this.qMap.suffix)
                fn = this.qMap.id + this.qMap.suffix.qmap_template(sm) + '.' + extn;
        }
        return this.tou.absURL(this.model, fn, true);
    }
}
/** @nocollapse */ QuestionComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QuestionComponent, deps: [{ token: forwardRef(() => QMAPService) }, { token: i1.MatSnackBar }, { token: i0.ElementRef }, { token: i0.ChangeDetectorRef }, { token: QuestionValidatorDirective, optional: true }], target: i0.ɵɵFactoryTarget.Component });
/** @nocollapse */ QuestionComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.9", type: QuestionComponent, selector: "[qmap-question]", inputs: { readOnly: "readOnly", qMap: "qMap", cssClass: ["qmap-class", "cssClass"], lightWeight: "lightWeight", autoSave: "autoSave", model: "model", vmodel: "vmodel", parentQuestion: "parentQuestion", templates: "templates", bunched: "bunched", scope: "scope", appearance: "appearance", _validator: ["validator", "_validator"] }, outputs: { outEvent: "qmap-change" }, queries: [{ propertyName: "_template", predicate: QMAPTemplate }], exportAs: ["touQuestion"], usesOnChanges: true, ngImport: i0, template: "<ng-container *ngIf=\"readOnly && readOnlyTemplate\" [ngTemplateOutlet]=\"readOnlyTemplate\" [ngTemplateOutletContext]=\"{self:this,model:model}\">\r\n\t\r\n</ng-container>\r\n\r\n<div *ngIf=\"readOnly && !readOnlyTemplate && ready\"  class=\"tou_question readOnly\" [ngClass]=\"cssClass\">\r\n\t<div *ngIf=\"!lightWeight\"><i>{{ qMap.title }}</i></div>\r\n\t<div [ngSwitch]=\"qMap.type\" class=\"tou_question\" [ngClass]=\"cssClass\">\r\n\r\n        <div *ngSwitchCase=\"'columns'\" class=\"row\">\r\n            <div class=\"col-sm-{{ 12/qMap.items.length }}\" *ngFor=\"let cur of qMap.items | qmap_filter:scope\" style=\"padding:15px;\">\r\n                <div qmap-question *ngIf=\"cur != 'blank'\" [qMap]=\"cur\" [model]=\"model\" [templates]=\"templates\" [parentQuestion]=\"this\" [readOnly]=\"true\" [appearance]=\"appearance\">\r\n                 </div>\r\n            </div>\r\n        </div>\r\n\r\n        <mat-tab-group *ngSwitchCase=\"'bunch'\" >\r\n\t\t\t<mat-tab *ngFor=\"let cur of qMap.items | qmap_filter:scope\" [label]=\"cur.name\">\r\n\t\t\t\t<div style=\"padding:15px;padding-left:25px;padding-right:25px;\">\r\n\t\t\t       <div qmap-question *ngFor=\"let cur2 of cur.items\" [qMap]=\"cur2\" [readOnly]=\"true\" [model]=\"model\" [templates]=\"templates\" [bunched]=\"true\" [appearance]=\"appearance\"></div>\r\n\t\t\t   </div>\r\n\t\t    </mat-tab>\r\n        </mat-tab-group>\r\n        \r\n        <ng-container *ngSwitchCase=\"'choice'\">\r\n            <div>{{ model[qMap.id] }}</div>\r\n            <div *ngIf=\"!lightWeight\">\r\n                <div *ngFor=\"let cur of onSelectQMap | qmap_filter:scope\" qmap-question [qMap]=\"cur\" [readOnly]=\"true\" [model]=\"model\" [parentQuestion]=\"this\" [templates]=\"templates\" [appearance]=\"appearance\"></div>\r\n            </div>\r\n        </ng-container>\r\n\r\n        <ng-container *ngSwitchCase=\"'image'\" >\r\n            <div *ngIf=\"!lightWeight && val\" >\r\n                <img [src]=\"getFileUri()\" style=\"max-width:100%\" />\r\n            </div>\r\n            <div *ngIf=\"lightWeight\" >\r\n                {{ val }}\r\n            </div>\r\n        </ng-container>\r\n\r\n        <ng-container *ngSwitchCase=\"'file'\" >\r\n            <div *ngIf=\"!lightWeight && val\" >\r\n                <a target=\"_blank\" [href]=\"getFileUri()\"><i class=\"fa fa-download fa-2x\"></i></a>\r\n            </div>\r\n            <div *ngIf=\"lightWeight\" >\r\n                {{ val }}\r\n            </div>\r\n        </ng-container>\r\n\t\t\r\n\t\t<ng-container *ngSwitchCase=\"'caption'\">{{ (qMap.title || qMap.value) | qmap_el: model }}</ng-container>\r\n\t\t<span *ngSwitchCase=\"'datetime'\" >{{ model[qMap.id] | qmap_moment:qMap.format ||'fromNow'}}</span>\r\n\t\t<span *ngSwitchCase=\"'date'\" >{{ model[qMap.id] | qmap_moment:qMap.format ||'YYYY-MMM-DD'}}</span>\r\n\t\t<span *ngSwitchCase=\"'time'\" >{{ model[qMap.id] | qmap_moment:qMap.format ||'HH:mm'}}</span>\r\n\t\t<ng-container *ngSwitchCase=\"'check'\" ><i class=\"fa\" [ngClass]=\"'' + model[qMap.id] == 'true'?'fa-check':'fa-times'\"></i></ng-container>\r\n\t\t<ng-container *ngSwitchCase=\"'boolean'\" ><i class=\"fa\" [ngClass]=\"'' + model[qMap.id] == 'true'?'fa-check':'fa-times'\"></i></ng-container>\r\n\t\t<div tou-object-question *ngSwitchCase=\"'object'\" [parent]=\"this\" class=\"tou_question\"></div>\r\n\t\t<ng-container *ngSwitchDefault>{{ model[qMap.id] }} </ng-container>\r\n\t</div>\r\n\t<br *ngIf=\"!lightWeight\"/>\r\n\t\r\n</div>\r\n\r\n<ng-container *ngIf=\"!readOnly && layoutTemplate\" [ngTemplateOutlet]=\"layoutTemplate\" [ngTemplateOutletContext]=\"{self:this,model:model}\">\r\n\t\r\n</ng-container>\r\n\r\n<ng-container *ngIf=\"!readOnly && !layoutTemplate && ready\" [ngSwitch]=\"qMap.type\">\r\n\t\r\n\t<span *ngSwitchCase=\"'caption'\">\r\n\t\t<h3 class=\"qmap_caption\">{{ qMap.title | qmap_el:model }}</h3>\r\n\t\t<p class=\"qmap_caption\" *ngIf=\"qMap.subtitle\">{{ qMap.subtitle | qmap_el: model }}</p>\r\n\t</span>\r\n\t\r\n\t<mat-tab-group *ngSwitchCase=\"'bunch'\" >\r\n\t\t<mat-tab *ngFor=\"let cur of qMap.items | qmap_filter:scope\" [label]=\"cur.name\">\r\n\t\t\t<div style=\"padding:15px;padding-left:25px;padding-right:25px;\">\r\n\t\t       <div qmap-question *ngFor=\"let cur2 of cur.items | qmap_filter:scope\" [qMap]=\"cur2\" [model]=\"model\" [templates]=\"templates\" [bunched]=\"true\"  (qmap-change)=\"outEvent.emit($event)\" [scope]=\"scope\" [appearance]=\"appearance\"></div>\r\n\t\t   </div>\r\n\t    </mat-tab>\r\n\t</mat-tab-group>\r\n\r\n\r\n\t\r\n\r\n\r\n\t<div *ngSwitchCase=\"'columns'\" class=\"row\">\r\n\t\t<div class=\"col-sm-{{ 12/qMap.items.length }}\" *ngFor=\"let cur of qMap.items | qmap_filter:scope\" style=\"padding:15px;\">\r\n\t\t\t<div qmap-question *ngIf=\"cur != 'blank'\" [qMap]=\"cur\" [model]=\"model\" [templates]=\"templates\" [parentQuestion]=\"this\" (qmap-change)=\"outEvent.emit($event)\" [appearance]=\"appearance\">\r\n\t\t \t</div>\r\n\t\t</div>\r\n\t</div>\r\n\r\n\r\n\t<tou-simple-question \t*ngSwitchCase=\"'check'\" \t\t[parent]=\"this\"\t class=\"tou_question\"></tou-simple-question>\r\n\t<tou-simple-question \t*ngSwitchCase=\"'qr'\" \t\t[parent]=\"this\"\t class=\"tou_question\"></tou-simple-question>\r\n\t<tou-simple-question \t*ngSwitchCase=\"'shorttext'\" \t[parent]=\"this\"\t class=\"tou_question\"></tou-simple-question>\r\n\t<tou-simple-question \t*ngSwitchCase=\"'text'\" \t\t\t[parent]=\"this\"\t class=\"tou_question\"></tou-simple-question>\r\n\t<tou-simple-question \t*ngSwitchCase=\"'number'\" \t\t[parent]=\"this\"\t class=\"tou_question\"></tou-simple-question>\r\n\t<tou-simple-question \t*ngSwitchCase=\"'boolean'\" \t\t[parent]=\"this\"\t class=\"tou_question\"></tou-simple-question>\r\n\t<tou-simple-question \t*ngSwitchCase=\"'json'\"\t \t\t[parent]=\"this\"\t class=\"tou_question\"></tou-simple-question>\r\n\t\r\n\t<tou-choice-question \t*ngSwitchCase=\"'choice'\" \t\t[parent]=\"this\"\t class=\"tou_question\"></tou-choice-question>\r\n\r\n\t<div tou-object-question\t*ngSwitchCase=\"'object'\" \t\t[parent]=\"this\"\t class=\"tou_question\"></div>\r\n\r\n\r\n\t<div tou-group-question \t*ngSwitchCase=\"'group'\" \t\t[parent]=\"this\"\t class=\"tou_question\"></div>\r\n\t\r\n\t<tou-location-question \t*ngSwitchCase=\"'location'\" \t\t[parent]=\"this\"\t class=\"tou_question\"></tou-location-question>\r\n\t\r\n\t<tou-date-question \t\t*ngSwitchCase=\"'datetime'\" \t\t[parent]=\"this\" [showDate]=\"true\" \t[showTime]=\"true\" \t class=\"tou_question\"></tou-date-question>\r\n\t\r\n\t<tou-date-question \t\t*ngSwitchCase=\"'date'\" \t\t\t[parent]=\"this\" [showDate]=\"true\" \t[showTime]=\"false\"\t class=\"tou_question\"></tou-date-question>\r\n\r\n\t<tou-date-question \t\t*ngSwitchCase=\"'time'\" \t\t\t[parent]=\"this\" [showDate]=\"false\" \t[showTime]=\"true\"\t class=\"tou_question\"></tou-date-question>\r\n\r\n\t<tou-simple-question \t*ngSwitchCase=\"null\" \t[parent]=\"this\"\t class=\"tou_question\"></tou-simple-question>\r\n\t\r\n\t<span *ngSwitchDefault><b>{{ qMap.type }}</b> unsupported</span>\r\n\r\n\t<ng-container *ngIf=\"nestTemplate\" \r\n\t\t[ngTemplateOutlet]=\"nestTemplate\"\r\n\t    [ngTemplateOutletContext]=\"this\">\r\n\t</ng-container>\r\n\r\n\t<ng-container *ngIf=\"!nestTemplate\">\r\n\t\t<div qmap-question *ngFor=\"let cur of subs | qmap_filter:scope ; let i = index\" [qMap]=\"cur\" [scope]=\"scope\" [templates]=\"templates\" [model]=\"model\" [vmodel]=\"vmodel\" [parentQuestion]=\"this\" qmap-class=\"sub\"  (qmap-change)=\"outEvent.emit($event)\" [autoSave]=\"autoSave\" [appearance]=\"appearance\"></div>\r\n\t</ng-container>\r\n\r\n</ng-container>\r\n\r\n", dependencies: [{ kind: "directive", type: i0.forwardRef(function () { return i3.NgClass; }), selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgForOf; }), selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgIf; }), selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgTemplateOutlet; }), selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgSwitch; }), selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgSwitchCase; }), selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgSwitchDefault; }), selector: "[ngSwitchDefault]" }, { kind: "component", type: i0.forwardRef(function () { return i4.MatTab; }), selector: "mat-tab", inputs: ["disabled"], exportAs: ["matTab"] }, { kind: "component", type: i0.forwardRef(function () { return i4.MatTabGroup; }), selector: "mat-tab-group", inputs: ["color", "disableRipple", "fitInkBarToContent", "mat-stretch-tabs"], exportAs: ["matTabGroup"] }, { kind: "component", type: i0.forwardRef(function () { return QuestionLocationComponent; }), selector: "tou-location-question" }, { kind: "component", type: i0.forwardRef(function () { return QuestionChoiceComponent; }), selector: "tou-choice-question,[tou-choice-question]" }, { kind: "component", type: i0.forwardRef(function () { return QuestionComponent; }), selector: "[qmap-question]", inputs: ["readOnly", "qMap", "qmap-class", "lightWeight", "autoSave", "model", "vmodel", "parentQuestion", "templates", "bunched", "scope", "appearance", "validator"], outputs: ["qmap-change"], exportAs: ["touQuestion"] }, { kind: "component", type: i0.forwardRef(function () { return QuestionSimpleComponent; }), selector: "tou-simple-question" }, { kind: "component", type: i0.forwardRef(function () { return QuestionObjectComponent; }), selector: "[tou-object-question]" }, { kind: "component", type: i0.forwardRef(function () { return QuestionDateComponent; }), selector: "tou-date-question", inputs: ["showTime", "showDate"] }, { kind: "component", type: i0.forwardRef(function () { return QuestionGroupComponent; }), selector: "[tou-group-question]" }, { kind: "pipe", type: i0.forwardRef(function () { return QFilterPipe; }), name: "qmap_filter" }, { kind: "pipe", type: i0.forwardRef(function () { return QMomentPipe; }), name: "qmap_moment" }, { kind: "pipe", type: i0.forwardRef(function () { return QMAPExpressionLanguage; }), name: "qmap_el" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QuestionComponent, decorators: [{
            type: Component,
            args: [{ selector: '[qmap-question]', exportAs: 'touQuestion', template: "<ng-container *ngIf=\"readOnly && readOnlyTemplate\" [ngTemplateOutlet]=\"readOnlyTemplate\" [ngTemplateOutletContext]=\"{self:this,model:model}\">\r\n\t\r\n</ng-container>\r\n\r\n<div *ngIf=\"readOnly && !readOnlyTemplate && ready\"  class=\"tou_question readOnly\" [ngClass]=\"cssClass\">\r\n\t<div *ngIf=\"!lightWeight\"><i>{{ qMap.title }}</i></div>\r\n\t<div [ngSwitch]=\"qMap.type\" class=\"tou_question\" [ngClass]=\"cssClass\">\r\n\r\n        <div *ngSwitchCase=\"'columns'\" class=\"row\">\r\n            <div class=\"col-sm-{{ 12/qMap.items.length }}\" *ngFor=\"let cur of qMap.items | qmap_filter:scope\" style=\"padding:15px;\">\r\n                <div qmap-question *ngIf=\"cur != 'blank'\" [qMap]=\"cur\" [model]=\"model\" [templates]=\"templates\" [parentQuestion]=\"this\" [readOnly]=\"true\" [appearance]=\"appearance\">\r\n                 </div>\r\n            </div>\r\n        </div>\r\n\r\n        <mat-tab-group *ngSwitchCase=\"'bunch'\" >\r\n\t\t\t<mat-tab *ngFor=\"let cur of qMap.items | qmap_filter:scope\" [label]=\"cur.name\">\r\n\t\t\t\t<div style=\"padding:15px;padding-left:25px;padding-right:25px;\">\r\n\t\t\t       <div qmap-question *ngFor=\"let cur2 of cur.items\" [qMap]=\"cur2\" [readOnly]=\"true\" [model]=\"model\" [templates]=\"templates\" [bunched]=\"true\" [appearance]=\"appearance\"></div>\r\n\t\t\t   </div>\r\n\t\t    </mat-tab>\r\n        </mat-tab-group>\r\n        \r\n        <ng-container *ngSwitchCase=\"'choice'\">\r\n            <div>{{ model[qMap.id] }}</div>\r\n            <div *ngIf=\"!lightWeight\">\r\n                <div *ngFor=\"let cur of onSelectQMap | qmap_filter:scope\" qmap-question [qMap]=\"cur\" [readOnly]=\"true\" [model]=\"model\" [parentQuestion]=\"this\" [templates]=\"templates\" [appearance]=\"appearance\"></div>\r\n            </div>\r\n        </ng-container>\r\n\r\n        <ng-container *ngSwitchCase=\"'image'\" >\r\n            <div *ngIf=\"!lightWeight && val\" >\r\n                <img [src]=\"getFileUri()\" style=\"max-width:100%\" />\r\n            </div>\r\n            <div *ngIf=\"lightWeight\" >\r\n                {{ val }}\r\n            </div>\r\n        </ng-container>\r\n\r\n        <ng-container *ngSwitchCase=\"'file'\" >\r\n            <div *ngIf=\"!lightWeight && val\" >\r\n                <a target=\"_blank\" [href]=\"getFileUri()\"><i class=\"fa fa-download fa-2x\"></i></a>\r\n            </div>\r\n            <div *ngIf=\"lightWeight\" >\r\n                {{ val }}\r\n            </div>\r\n        </ng-container>\r\n\t\t\r\n\t\t<ng-container *ngSwitchCase=\"'caption'\">{{ (qMap.title || qMap.value) | qmap_el: model }}</ng-container>\r\n\t\t<span *ngSwitchCase=\"'datetime'\" >{{ model[qMap.id] | qmap_moment:qMap.format ||'fromNow'}}</span>\r\n\t\t<span *ngSwitchCase=\"'date'\" >{{ model[qMap.id] | qmap_moment:qMap.format ||'YYYY-MMM-DD'}}</span>\r\n\t\t<span *ngSwitchCase=\"'time'\" >{{ model[qMap.id] | qmap_moment:qMap.format ||'HH:mm'}}</span>\r\n\t\t<ng-container *ngSwitchCase=\"'check'\" ><i class=\"fa\" [ngClass]=\"'' + model[qMap.id] == 'true'?'fa-check':'fa-times'\"></i></ng-container>\r\n\t\t<ng-container *ngSwitchCase=\"'boolean'\" ><i class=\"fa\" [ngClass]=\"'' + model[qMap.id] == 'true'?'fa-check':'fa-times'\"></i></ng-container>\r\n\t\t<div tou-object-question *ngSwitchCase=\"'object'\" [parent]=\"this\" class=\"tou_question\"></div>\r\n\t\t<ng-container *ngSwitchDefault>{{ model[qMap.id] }} </ng-container>\r\n\t</div>\r\n\t<br *ngIf=\"!lightWeight\"/>\r\n\t\r\n</div>\r\n\r\n<ng-container *ngIf=\"!readOnly && layoutTemplate\" [ngTemplateOutlet]=\"layoutTemplate\" [ngTemplateOutletContext]=\"{self:this,model:model}\">\r\n\t\r\n</ng-container>\r\n\r\n<ng-container *ngIf=\"!readOnly && !layoutTemplate && ready\" [ngSwitch]=\"qMap.type\">\r\n\t\r\n\t<span *ngSwitchCase=\"'caption'\">\r\n\t\t<h3 class=\"qmap_caption\">{{ qMap.title | qmap_el:model }}</h3>\r\n\t\t<p class=\"qmap_caption\" *ngIf=\"qMap.subtitle\">{{ qMap.subtitle | qmap_el: model }}</p>\r\n\t</span>\r\n\t\r\n\t<mat-tab-group *ngSwitchCase=\"'bunch'\" >\r\n\t\t<mat-tab *ngFor=\"let cur of qMap.items | qmap_filter:scope\" [label]=\"cur.name\">\r\n\t\t\t<div style=\"padding:15px;padding-left:25px;padding-right:25px;\">\r\n\t\t       <div qmap-question *ngFor=\"let cur2 of cur.items | qmap_filter:scope\" [qMap]=\"cur2\" [model]=\"model\" [templates]=\"templates\" [bunched]=\"true\"  (qmap-change)=\"outEvent.emit($event)\" [scope]=\"scope\" [appearance]=\"appearance\"></div>\r\n\t\t   </div>\r\n\t    </mat-tab>\r\n\t</mat-tab-group>\r\n\r\n\r\n\t\r\n\r\n\r\n\t<div *ngSwitchCase=\"'columns'\" class=\"row\">\r\n\t\t<div class=\"col-sm-{{ 12/qMap.items.length }}\" *ngFor=\"let cur of qMap.items | qmap_filter:scope\" style=\"padding:15px;\">\r\n\t\t\t<div qmap-question *ngIf=\"cur != 'blank'\" [qMap]=\"cur\" [model]=\"model\" [templates]=\"templates\" [parentQuestion]=\"this\" (qmap-change)=\"outEvent.emit($event)\" [appearance]=\"appearance\">\r\n\t\t \t</div>\r\n\t\t</div>\r\n\t</div>\r\n\r\n\r\n\t<tou-simple-question \t*ngSwitchCase=\"'check'\" \t\t[parent]=\"this\"\t class=\"tou_question\"></tou-simple-question>\r\n\t<tou-simple-question \t*ngSwitchCase=\"'qr'\" \t\t[parent]=\"this\"\t class=\"tou_question\"></tou-simple-question>\r\n\t<tou-simple-question \t*ngSwitchCase=\"'shorttext'\" \t[parent]=\"this\"\t class=\"tou_question\"></tou-simple-question>\r\n\t<tou-simple-question \t*ngSwitchCase=\"'text'\" \t\t\t[parent]=\"this\"\t class=\"tou_question\"></tou-simple-question>\r\n\t<tou-simple-question \t*ngSwitchCase=\"'number'\" \t\t[parent]=\"this\"\t class=\"tou_question\"></tou-simple-question>\r\n\t<tou-simple-question \t*ngSwitchCase=\"'boolean'\" \t\t[parent]=\"this\"\t class=\"tou_question\"></tou-simple-question>\r\n\t<tou-simple-question \t*ngSwitchCase=\"'json'\"\t \t\t[parent]=\"this\"\t class=\"tou_question\"></tou-simple-question>\r\n\t\r\n\t<tou-choice-question \t*ngSwitchCase=\"'choice'\" \t\t[parent]=\"this\"\t class=\"tou_question\"></tou-choice-question>\r\n\r\n\t<div tou-object-question\t*ngSwitchCase=\"'object'\" \t\t[parent]=\"this\"\t class=\"tou_question\"></div>\r\n\r\n\r\n\t<div tou-group-question \t*ngSwitchCase=\"'group'\" \t\t[parent]=\"this\"\t class=\"tou_question\"></div>\r\n\t\r\n\t<tou-location-question \t*ngSwitchCase=\"'location'\" \t\t[parent]=\"this\"\t class=\"tou_question\"></tou-location-question>\r\n\t\r\n\t<tou-date-question \t\t*ngSwitchCase=\"'datetime'\" \t\t[parent]=\"this\" [showDate]=\"true\" \t[showTime]=\"true\" \t class=\"tou_question\"></tou-date-question>\r\n\t\r\n\t<tou-date-question \t\t*ngSwitchCase=\"'date'\" \t\t\t[parent]=\"this\" [showDate]=\"true\" \t[showTime]=\"false\"\t class=\"tou_question\"></tou-date-question>\r\n\r\n\t<tou-date-question \t\t*ngSwitchCase=\"'time'\" \t\t\t[parent]=\"this\" [showDate]=\"false\" \t[showTime]=\"true\"\t class=\"tou_question\"></tou-date-question>\r\n\r\n\t<tou-simple-question \t*ngSwitchCase=\"null\" \t[parent]=\"this\"\t class=\"tou_question\"></tou-simple-question>\r\n\t\r\n\t<span *ngSwitchDefault><b>{{ qMap.type }}</b> unsupported</span>\r\n\r\n\t<ng-container *ngIf=\"nestTemplate\" \r\n\t\t[ngTemplateOutlet]=\"nestTemplate\"\r\n\t    [ngTemplateOutletContext]=\"this\">\r\n\t</ng-container>\r\n\r\n\t<ng-container *ngIf=\"!nestTemplate\">\r\n\t\t<div qmap-question *ngFor=\"let cur of subs | qmap_filter:scope ; let i = index\" [qMap]=\"cur\" [scope]=\"scope\" [templates]=\"templates\" [model]=\"model\" [vmodel]=\"vmodel\" [parentQuestion]=\"this\" qmap-class=\"sub\"  (qmap-change)=\"outEvent.emit($event)\" [autoSave]=\"autoSave\" [appearance]=\"appearance\"></div>\r\n\t</ng-container>\r\n\r\n</ng-container>\r\n\r\n" }]
        }], ctorParameters: function () {
        return [{ type: QMAPService, decorators: [{
                        type: Inject,
                        args: [forwardRef(() => QMAPService)]
                    }] }, { type: i1.MatSnackBar }, { type: i0.ElementRef }, { type: i0.ChangeDetectorRef }, { type: QuestionValidatorDirective, decorators: [{
                        type: Optional
                    }] }];
    }, propDecorators: { readOnly: [{
                type: Input
            }], qMap: [{
                type: Input
            }], cssClass: [{
                type: Input,
                args: ['qmap-class']
            }], lightWeight: [{
                type: Input
            }], autoSave: [{
                type: Input
            }], model: [{
                type: Input
            }], vmodel: [{
                type: Input
            }], parentQuestion: [{
                type: Input
            }], outEvent: [{
                type: Output,
                args: ['qmap-change']
            }], templates: [{
                type: Input
            }], bunched: [{
                type: Input
            }], scope: [{
                type: Input
            }], appearance: [{
                type: Input
            }], _validator: [{
                type: Input,
                args: ['validator']
            }], _template: [{
                type: ContentChildren,
                args: [QMAPTemplate]
            }] } });
class SubQuestionComponent {
    constructor() {
        this.outEvent = new EventEmitter();
        this.templates = {};
    }
    ngOnInit() {
        this.parent.widget = this;
        if (!this.bypass)
            this.parent.templates.filter(t => (t.qType == this.parent.qMap.type) || (t.qMap == this.parent.qMap.id)).forEach(tt => {
                this.templates[tt.qMode] = tt.template;
            });
        let defaultV = null;
        this.initValue();
        this.subValues(this.parent.val);
        this.parent._validatorReg();
    }
    initValue() {
        let defaultVal = this.parent.qMap.default;
        let v = this.parent.val;
        if (v != undefined) {
            this.localVal = v;
        }
        else if (defaultVal || defaultVal === false) {
            let dv = this.castDefaultValue(defaultVal);
            this.localVal = dv;
            this.parent.val = dv;
        }
    }
    castDefaultValue(dv) {
        return dv;
    }
    parentChange(change) {
        this.localVal = this.parent.val;
    }
    subValues(val) {
        val = val || this.parent.val;
        let oldCache = this.parent.subs;
        this.parent.subs = [];
        let _subs = this.parent.subs;
        // default mode is there are subvalues onSelect when there is any value
        if (this.parent.qMap.onSelect && val) {
            this.parent.qMap.onSelect.forEach((i) => _subs.push(i));
        }
    }
    applyValue(obj) {
        this.parent.val = obj;
        this.subValues(obj);
        this.parent.updated(obj, this);
        // if no model binding was supplied and its got an out, then auto clear it
        if (obj && this.parent.blankModel) {
            this.applyValue(null);
        }
        if (this.parent && this.parent.validator) {
            this.parent.validator.updateQuestionState(this.parent, this.isValid());
        }
        //this.parent.changeDetector.detectChanges()
    }
    copyAndAdd(obj, add) {
        var json = {};
        Object.keys(obj).forEach((k) => json[k] = obj[k]);
        Object.keys(add).forEach((k) => json[k] = add[k]);
        return json;
    }
    isValid() {
        let b = !this.parent.qMap.required || this.parent.val;
        this.invalidIcon = 'fa-asterisk';
        if (b) {
            this.invalidColour = null;
            //this.invalidIcon = null
            this.invalidTooltip = null;
        }
        else {
            this.invalidColour = 'text-danger';
            this.invalidTooltip = 'Field is required';
        }
        return b;
    }
    addSubQuestion(a) {
        if (typeof a == 'string' && a.startsWith('#')) {
            if (this.parent.qMap[a.substring(1)]) {
                var arr = this.parent.qMap[a.substring(1)];
                arr.forEach(cur => this.parent.subs.push(cur));
            }
        }
        else if (Array.isArray(a)) {
            a.forEach(cur => this.addSubQuestion(cur));
        }
        else {
            this.parent.subs.push(a);
        }
    }
    ngOnDestroy() {
        this.parent = null;
    }
}
/** @nocollapse */ SubQuestionComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: SubQuestionComponent, deps: [], target: i0.ɵɵFactoryTarget.Directive });
/** @nocollapse */ SubQuestionComponent.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.2.9", type: SubQuestionComponent, inputs: { parent: "parent", bypass: "bypass" }, outputs: { outEvent: "qmap-change" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: SubQuestionComponent, decorators: [{
            type: Directive
        }], propDecorators: { parent: [{
                type: Input,
                args: ['parent']
            }], bypass: [{
                type: Input,
                args: ['bypass']
            }], outEvent: [{
                type: Output,
                args: ['qmap-change']
            }] } });
class QuestionObjectComponent extends SubQuestionComponent {
    constructor(service) {
        super();
        this.service = service;
        this.addQMap = [];
        this.pulldownItems = [];
        this.lock = 0;
        this.control = new FormControl();
    }
    ngOnInit() {
        super.ngOnInit();
        if (this.parent.qMap.style == 'pulldown') {
            let items = this.service.objectsForQMap(this.parent.qMap, null, this.parent.superModel());
            if (this.parent.qMap.cache)
                items = of(this.parent.qMap.cache);
            items.subscribe(s => {
                this.pulldownItems = s;
                if (this.localVal)
                    this.localVal = this.pulldownItems.find(i => i.id == this.localVal.id);
            });
        }
        else {
            this.results = this.control.valueChanges
                .pipe(debounceTime(1000), flatMap(name => {
                if (this.service.isModel(name))
                    return name.fetchObservable().map(i => [i]);
                else
                    return this.searchObservable(name);
            }));
        }
    }
    compareW(a, b) {
        return a && b && a.id == b.id;
    }
    selectLightVal(e) {
    }
    selectVal(e) {
        let v = e.value || e.option.value.value;
        this.localVal = v;
        this.applyValue(v);
    }
    initValue() {
        super.initValue();
        if (this.localVal && Object.keys(this.localVal).length == 2 && this.localVal.type && this.localVal.id) {
            let v = this.service.findCachedModel(this.parent.qMap, this.localVal.id);
            if (v)
                this.localVal = v;
            else if (this.parent.qMap.autoload) {
                let type = this.localVal.type;
                let model = this.service.makeModel(this.parent.qMap).set(this.localVal);
                model.fetchObservable().subscribe(s => {
                    this.control.setValue(model);
                }, e => console.warn(this.localVal.id + " " + this.localVal.type + " couldnt load " + e.message));
            }
        }
        this.isAdd = (this.localVal && this.localVal.id == 'new');
        this.addQMap = this.service.objectTypeQMap(this.parent.qMap.obj_type);
        this.control.setValue(this.localVal);
    }
    parentChange(a) {
        this.lock++;
        if (this.lock > 10) {
            console.log('Breaking out of spin for ' + this.parent.qMap.id);
            return;
        }
        super.parentChange(a);
        this.control.setValue(this.localVal);
    }
    searchObservable(name) {
        if (!name || name == '') {
            if (this.parent.val) {
                return of([this.parent.val]);
            }
            else
                return of([]);
        }
        else {
            return this.service.objectsForQMap(this.parent.qMap, name, this.parent.superModel()).pipe(map(items => {
                if (this.parent.qMap.addable && this.parent.qMap.style == 'inline') {
                    this.applyValue(name);
                }
                this.typing = true;
                return items;
            }));
        }
    }
    // checks for partially typed text that doesnt match selected node, fallback is to nullify column
    checkVal(e) {
        this.typing = false;
        console.log('cv');
        this.clicked = false;
        setTimeout(() => {
            if (e == '') {
                this.applyValue(null);
            }
            else if (!this.clicked && this.parent.model[this.parent.qMap.id] && this.parent.model[this.parent.qMap.id]['name'] != e) {
                this.control.setValue(this.localVal);
            }
        }, 10);
    }
    applyValue(v) {
        this.typing = false;
        let ts = typeof v;
        this.localVal = v;
        if (!v && this.control)
            this.control.setValue(null);
        if (this.parent.qMap.addable && this.parent.qMap.style == 'inline' && ts == 'string') {
            this.localVal = { id: 'new', type: this.parent.qMap.obj_type, name: v };
            super.applyValue(this.localVal);
        }
        else if (this.parent.qMap.addable && this.parent.qMap.style == 'inline' && ts == 'object') {
            super.applyValue(this.localVal);
            this.control.setValue(this.localVal ? this.localVal.name : '', { emitEvent: false });
        }
        else if (v == 'add' && this.parent.qMap.style != 'inline') {
            this.isAdd = true;
            this.localVal = { id: 'new', type: this.parent.qMap.obj_type };
            super.applyValue(this.localVal);
        }
        else {
            this.isAdd = false;
            super.applyValue(v);
        }
    }
    displayFn(v) {
        let a = this;
        let actualThis = a.template._parentView.parent.component;
        if (actualThis) {
            actualThis.clicked = true;
            if (v && actualThis.localVal != v) {
                actualThis.applyValue(v);
            }
            else if (actualThis.parent)
                v = v || actualThis.parent.val;
        }
        if (v == 'add')
            return 'Add new ...';
        else
            return !v ? '' : v['name'] || v['id'];
    }
    supportedTemplates() {
        return ['objectLayout'];
    }
}
/** @nocollapse */ QuestionObjectComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QuestionObjectComponent, deps: [{ token: forwardRef(() => QMAPService) }], target: i0.ɵɵFactoryTarget.Component });
/** @nocollapse */ QuestionObjectComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.9", type: QuestionObjectComponent, selector: "[tou-object-question]", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"templates['inner_layout']\" [ngTemplateOutlet]=\"templates['inner_layout']\"\r\n        [ngTemplateOutletContext]=\"{localVal:localVal,templates:parent.templates,parent:parent,self:this}\">\r\n</ng-container>\r\n\r\n<ng-container *ngIf=\"!templates['inner_layout']\">\r\n\t<ng-container *ngIf=\"parent.readOnly\">\r\n\t\t{{ localVal ? ( localVal.name ? localVal.name : localVal.id ) : \"\"}}\r\n\t</ng-container>\r\n\t<ng-container *ngIf=\"!parent.readOnly && parent.qMap.style == 'pulldown'\">\r\n\r\n\t\t<mat-form-field *ngIf=\"!parent.lightWeight\" class=\"full-width\" [floatLabel]=\"parent.qMap.float || 'auto'\" [appearance]=\"parent.appearance\">\r\n\t\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t\t\t<mat-select  class=\"full-width\" [placeholder]=\"parent.qMap.title | qmap_el: parent \" [(ngModel)]=\"localVal\"  [required]=\"parent.qMap.required\" (selectionChange)=\"selectVal($event)\" [compareWith]=\"compareW\">\r\n\t\t\t\t<mat-option *ngFor=\"let cur of pulldownItems\" [value]=\"cur\">\r\n\t\t\t\t{{ cur.name || cur.id }}\r\n\t\t\t\t</mat-option>\r\n\t\t\t\t<!--\r\n\t\t\t\t<mat-option [value]=\"null\">\r\n\t\t\t\t-\r\n\t\t\t\t</mat-option>\r\n\t\t\t\t-->\r\n\t\t\t</mat-select>\r\n\t\t\t<i *ngIf=\"parent.qMap.required\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\t\t\t<i *ngIf=\"parent.qMap.subtitle\" align=\"end\">{{ parent.qMap.subtitle | qmap_el: parent }}</i>\r\n\t\t</mat-form-field>\r\n\t\t<select  class=\"full-width\" *ngIf=\"parent.lightWeight\" [(ngModel)]=\"localVal\"  (change)=\"selectVal({value:localVal})\">\r\n\t\t\t<option *ngFor=\"let cur of pulldownItems\" [ngValue]=\"cur\">\r\n\t\t\t{{ cur.name || cur.id }}\r\n\t\t\t</option>\r\n\t\t\t<option [value]=\"null\">-</option>\r\n\t\t</select>\r\n\t</ng-container>\r\n\r\n\t<ng-container *ngIf=\"!parent.readOnly && parent.qMap.style != 'pulldown'\">\t\t\r\n\t\t<ng-container *ngIf=\"localVal && !isAdd && templates['objectLayout']\"\r\n\t\t\t[ngTemplateOutlet]=\"templates['objectLayout']\"\r\n\t\t\t[ngTemplateOutletContext]=\"this\">\r\n\t\t</ng-container>\r\n\r\n\t\t<ng-container *ngIf=\"localVal && !isAdd && !templates['objectLayout'] && parent.qMap.style == 'block'\">\r\n\t\t\t<mat-card (click)=\"localVal = null\">\r\n\t\t\t\t<mat-card-header>\r\n\r\n\t\t\t\t<span mat-card-avatar><img src=\"image.png\"class=\"full-width\"/> </span>\r\n\t\t\t\t{{ localVal.name }}  <div class=\"pull-right\" (click)=\"applyValue(null)\"><i class=\"fa fa-times\"></i></div>\r\n\r\n\t\t\t\t</mat-card-header>\r\n\t\t\t</mat-card>\r\n\t\t</ng-container>\r\n\r\n\t\t<ng-container *ngIf=\"localVal && isAdd\">\r\n\t\t\t<ng-container *ngIf=\"templates['child_layout']\"\r\n\t\t\t\t[ngTemplateOutlet]=\"templates['child_layout']\"\r\n\t\t\t\t[ngTemplateOutletContext]=\"{model:localVal,templates:parent.templates,parent:parent}\">\r\n\r\n\t\t\t</ng-container>\r\n\r\n\t\t\t<mat-card  *ngIf=\"!templates['child_layout']\">\r\n\t\t\t\t<mat-card-header>\r\n\t\t\t\t\t<div>\r\n\t\t\t\t\tAdd new {{ parent.qMap.obj_type }}  <div class=\"close-btn\" (click)=\"applyValue(null)\"><i class=\"fa fa-times\"></i></div>\r\n\t\t\t\t</div>\r\n\t\t\t\t</mat-card-header>\r\n\r\n\t\t\t\t<mat-card-content qmap-question *ngFor=\"let curQMap of addQMap\" [qMap]=\"curQMap\" [templates]=\"parent.templates\" [model]=\"localVal\" qmap-class=\"sub array\" [parentQuestion]=\"parent\"></mat-card-content>\r\n\t\t\t</mat-card>\r\n\t\t\t\r\n\t\t</ng-container>\r\n\r\n\t\t<ng-container *ngIf=\"!localVal || parent.qMap.style != 'block'\">\r\n\r\n\t\t\t<ng-container *ngIf=\"templates['picker_layout']\"\r\n\t\t\t\t[ngTemplateOutlet]=\"templates['picker_layout']\"\r\n\t\t\t\t[ngTemplateOutletContext]=\"{self:this}\">\r\n\r\n\t\t\t</ng-container>\r\n\t\t\t<ng-container *ngIf=\"!templates['picker_layout']\">\r\n\t\t\t\t<mat-form-field class=\"full-width\"  [ngClass]=\"cssClass\" [floatLabel]=\"parent.qMap.float || 'auto'\" [appearance]=\"parent.appearance\">\r\n\t\t\t\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t\t\t\t\t<input matInput [placeholder]=\"parent.qMap.title | qmap_el:parent\" [matAutocomplete]=\"auto\" [formControl]=\"control\" (blur)=\"checkVal($event.target.value)\"/>\r\n\t\t\t\t\t<img *ngIf=\"localVal && !parent.qMap.showImage == false\" matPrefix src=\"image.png\" class=\"sm-icon\" />\r\n\r\n\t\t\t\t\t<i *ngIf=\"parent.qMap.required && !localVal\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\r\n\t\t\t\t\t<a matSuffix *ngIf=\"localVal\" (click)=\"applyValue(null)\"><i  class=\"fa fa-times\"></i></a>\r\n\t\t\t\t\t\r\n\t\t\t\t\t<i matSuffix class=\"fa fa-search\" [matTooltip]=\"parent.qMap.obj_type\"></i>\r\n\r\n\t\t\t\t\t<mat-hint align=\"end\">{{ parent.qMap.subtitle | qmap_el:parent }}</mat-hint>\r\n\t\t\t\t</mat-form-field>\r\n\r\n\t\t\t\t<mat-autocomplete #auto=\"matAutocomplete\"  [displayWith]=\"displayFn\" >\r\n\t\t\t\t\r\n\t\t\t\t\t\r\n\t\t\t\t<mat-option *ngFor=\"let item of results | async\" [value]=\"item\">\r\n\t\t\t\t\t<img src=\"image.png\" class=\"sm-icon\"/> \r\n\t\t\t\t\t{{ item.name }}\r\n\t\t\t\t\t<small class=\"light tou_id\">{{ item.id }}</small>\r\n\t\t\t\t</mat-option>\r\n\t\t\t\t<mat-option *ngIf=\"parent.qMap.addable && parent.qMap.style != 'inline'\" [value]=\"'add'\">\r\n\t\t\t\t\t<i class=\"fa fa-plus\"></i>\r\n\t\t\t\t\tAdd new {{ parent.qMap.obj_type }}\r\n\t\t\t\t</mat-option>\r\n\t\t\t\t</mat-autocomplete>\r\n\t\t\t</ng-container>\r\n\r\n\t\t</ng-container>\r\n\r\n\r\n\t</ng-container>\r\n</ng-container>\r\n\r\n", dependencies: [{ kind: "directive", type: i0.forwardRef(function () { return i3.NgClass; }), selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgForOf; }), selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgIf; }), selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgTemplateOutlet; }), selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i0.forwardRef(function () { return i7.NgSelectOption; }), selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i0.forwardRef(function () { return i7.ɵNgSelectMultipleOption; }), selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i0.forwardRef(function () { return i7.DefaultValueAccessor; }), selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i0.forwardRef(function () { return i7.SelectControlValueAccessor; }), selector: "select:not([multiple])[formControlName],select:not([multiple])[formControl],select:not([multiple])[ngModel]", inputs: ["compareWith"] }, { kind: "directive", type: i0.forwardRef(function () { return i7.NgControlStatus; }), selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i0.forwardRef(function () { return i7.RequiredValidator; }), selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i0.forwardRef(function () { return i7.NgModel; }), selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: i0.forwardRef(function () { return i7.FormControlDirective; }), selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: i0.forwardRef(function () { return i8.MatAutocomplete; }), selector: "mat-autocomplete", inputs: ["disableRipple", "hideSingleSelectionIndicator"], exportAs: ["matAutocomplete"] }, { kind: "component", type: i0.forwardRef(function () { return i9.MatOption; }), selector: "mat-option", exportAs: ["matOption"] }, { kind: "directive", type: i0.forwardRef(function () { return i8.MatAutocompleteTrigger; }), selector: "input[matAutocomplete], textarea[matAutocomplete]", exportAs: ["matAutocompleteTrigger"] }, { kind: "component", type: i0.forwardRef(function () { return i10.MatFormField; }), selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i0.forwardRef(function () { return i10.MatLabel; }), selector: "mat-label" }, { kind: "directive", type: i0.forwardRef(function () { return i10.MatHint; }), selector: "mat-hint", inputs: ["align", "id"] }, { kind: "directive", type: i0.forwardRef(function () { return i10.MatPrefix; }), selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i0.forwardRef(function () { return i10.MatSuffix; }), selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "component", type: i0.forwardRef(function () { return i11.MatSelect; }), selector: "mat-select", inputs: ["disabled", "disableRipple", "tabIndex", "hideSingleSelectionIndicator"], exportAs: ["matSelect"] }, { kind: "component", type: i0.forwardRef(function () { return i12.MatCard; }), selector: "mat-card", inputs: ["appearance"], exportAs: ["matCard"] }, { kind: "directive", type: i0.forwardRef(function () { return i12.MatCardAvatar; }), selector: "[mat-card-avatar], [matCardAvatar]" }, { kind: "directive", type: i0.forwardRef(function () { return i12.MatCardContent; }), selector: "mat-card-content" }, { kind: "component", type: i0.forwardRef(function () { return i12.MatCardHeader; }), selector: "mat-card-header" }, { kind: "directive", type: i0.forwardRef(function () { return i13.MatInput; }), selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "directive", type: i0.forwardRef(function () { return i14.MatTooltip; }), selector: "[matTooltip]", exportAs: ["matTooltip"] }, { kind: "component", type: i0.forwardRef(function () { return QuestionComponent; }), selector: "[qmap-question]", inputs: ["readOnly", "qMap", "qmap-class", "lightWeight", "autoSave", "model", "vmodel", "parentQuestion", "templates", "bunched", "scope", "appearance", "validator"], outputs: ["qmap-change"], exportAs: ["touQuestion"] }, { kind: "pipe", type: i0.forwardRef(function () { return i3.AsyncPipe; }), name: "async" }, { kind: "pipe", type: i0.forwardRef(function () { return QMAPExpressionLanguage; }), name: "qmap_el" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QuestionObjectComponent, decorators: [{
            type: Component,
            args: [{ selector: '[tou-object-question]', template: "<ng-container *ngIf=\"templates['inner_layout']\" [ngTemplateOutlet]=\"templates['inner_layout']\"\r\n        [ngTemplateOutletContext]=\"{localVal:localVal,templates:parent.templates,parent:parent,self:this}\">\r\n</ng-container>\r\n\r\n<ng-container *ngIf=\"!templates['inner_layout']\">\r\n\t<ng-container *ngIf=\"parent.readOnly\">\r\n\t\t{{ localVal ? ( localVal.name ? localVal.name : localVal.id ) : \"\"}}\r\n\t</ng-container>\r\n\t<ng-container *ngIf=\"!parent.readOnly && parent.qMap.style == 'pulldown'\">\r\n\r\n\t\t<mat-form-field *ngIf=\"!parent.lightWeight\" class=\"full-width\" [floatLabel]=\"parent.qMap.float || 'auto'\" [appearance]=\"parent.appearance\">\r\n\t\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t\t\t<mat-select  class=\"full-width\" [placeholder]=\"parent.qMap.title | qmap_el: parent \" [(ngModel)]=\"localVal\"  [required]=\"parent.qMap.required\" (selectionChange)=\"selectVal($event)\" [compareWith]=\"compareW\">\r\n\t\t\t\t<mat-option *ngFor=\"let cur of pulldownItems\" [value]=\"cur\">\r\n\t\t\t\t{{ cur.name || cur.id }}\r\n\t\t\t\t</mat-option>\r\n\t\t\t\t<!--\r\n\t\t\t\t<mat-option [value]=\"null\">\r\n\t\t\t\t-\r\n\t\t\t\t</mat-option>\r\n\t\t\t\t-->\r\n\t\t\t</mat-select>\r\n\t\t\t<i *ngIf=\"parent.qMap.required\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\t\t\t<i *ngIf=\"parent.qMap.subtitle\" align=\"end\">{{ parent.qMap.subtitle | qmap_el: parent }}</i>\r\n\t\t</mat-form-field>\r\n\t\t<select  class=\"full-width\" *ngIf=\"parent.lightWeight\" [(ngModel)]=\"localVal\"  (change)=\"selectVal({value:localVal})\">\r\n\t\t\t<option *ngFor=\"let cur of pulldownItems\" [ngValue]=\"cur\">\r\n\t\t\t{{ cur.name || cur.id }}\r\n\t\t\t</option>\r\n\t\t\t<option [value]=\"null\">-</option>\r\n\t\t</select>\r\n\t</ng-container>\r\n\r\n\t<ng-container *ngIf=\"!parent.readOnly && parent.qMap.style != 'pulldown'\">\t\t\r\n\t\t<ng-container *ngIf=\"localVal && !isAdd && templates['objectLayout']\"\r\n\t\t\t[ngTemplateOutlet]=\"templates['objectLayout']\"\r\n\t\t\t[ngTemplateOutletContext]=\"this\">\r\n\t\t</ng-container>\r\n\r\n\t\t<ng-container *ngIf=\"localVal && !isAdd && !templates['objectLayout'] && parent.qMap.style == 'block'\">\r\n\t\t\t<mat-card (click)=\"localVal = null\">\r\n\t\t\t\t<mat-card-header>\r\n\r\n\t\t\t\t<span mat-card-avatar><img src=\"image.png\"class=\"full-width\"/> </span>\r\n\t\t\t\t{{ localVal.name }}  <div class=\"pull-right\" (click)=\"applyValue(null)\"><i class=\"fa fa-times\"></i></div>\r\n\r\n\t\t\t\t</mat-card-header>\r\n\t\t\t</mat-card>\r\n\t\t</ng-container>\r\n\r\n\t\t<ng-container *ngIf=\"localVal && isAdd\">\r\n\t\t\t<ng-container *ngIf=\"templates['child_layout']\"\r\n\t\t\t\t[ngTemplateOutlet]=\"templates['child_layout']\"\r\n\t\t\t\t[ngTemplateOutletContext]=\"{model:localVal,templates:parent.templates,parent:parent}\">\r\n\r\n\t\t\t</ng-container>\r\n\r\n\t\t\t<mat-card  *ngIf=\"!templates['child_layout']\">\r\n\t\t\t\t<mat-card-header>\r\n\t\t\t\t\t<div>\r\n\t\t\t\t\tAdd new {{ parent.qMap.obj_type }}  <div class=\"close-btn\" (click)=\"applyValue(null)\"><i class=\"fa fa-times\"></i></div>\r\n\t\t\t\t</div>\r\n\t\t\t\t</mat-card-header>\r\n\r\n\t\t\t\t<mat-card-content qmap-question *ngFor=\"let curQMap of addQMap\" [qMap]=\"curQMap\" [templates]=\"parent.templates\" [model]=\"localVal\" qmap-class=\"sub array\" [parentQuestion]=\"parent\"></mat-card-content>\r\n\t\t\t</mat-card>\r\n\t\t\t\r\n\t\t</ng-container>\r\n\r\n\t\t<ng-container *ngIf=\"!localVal || parent.qMap.style != 'block'\">\r\n\r\n\t\t\t<ng-container *ngIf=\"templates['picker_layout']\"\r\n\t\t\t\t[ngTemplateOutlet]=\"templates['picker_layout']\"\r\n\t\t\t\t[ngTemplateOutletContext]=\"{self:this}\">\r\n\r\n\t\t\t</ng-container>\r\n\t\t\t<ng-container *ngIf=\"!templates['picker_layout']\">\r\n\t\t\t\t<mat-form-field class=\"full-width\"  [ngClass]=\"cssClass\" [floatLabel]=\"parent.qMap.float || 'auto'\" [appearance]=\"parent.appearance\">\r\n\t\t\t\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t\t\t\t\t<input matInput [placeholder]=\"parent.qMap.title | qmap_el:parent\" [matAutocomplete]=\"auto\" [formControl]=\"control\" (blur)=\"checkVal($event.target.value)\"/>\r\n\t\t\t\t\t<img *ngIf=\"localVal && !parent.qMap.showImage == false\" matPrefix src=\"image.png\" class=\"sm-icon\" />\r\n\r\n\t\t\t\t\t<i *ngIf=\"parent.qMap.required && !localVal\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\r\n\t\t\t\t\t<a matSuffix *ngIf=\"localVal\" (click)=\"applyValue(null)\"><i  class=\"fa fa-times\"></i></a>\r\n\t\t\t\t\t\r\n\t\t\t\t\t<i matSuffix class=\"fa fa-search\" [matTooltip]=\"parent.qMap.obj_type\"></i>\r\n\r\n\t\t\t\t\t<mat-hint align=\"end\">{{ parent.qMap.subtitle | qmap_el:parent }}</mat-hint>\r\n\t\t\t\t</mat-form-field>\r\n\r\n\t\t\t\t<mat-autocomplete #auto=\"matAutocomplete\"  [displayWith]=\"displayFn\" >\r\n\t\t\t\t\r\n\t\t\t\t\t\r\n\t\t\t\t<mat-option *ngFor=\"let item of results | async\" [value]=\"item\">\r\n\t\t\t\t\t<img src=\"image.png\" class=\"sm-icon\"/> \r\n\t\t\t\t\t{{ item.name }}\r\n\t\t\t\t\t<small class=\"light tou_id\">{{ item.id }}</small>\r\n\t\t\t\t</mat-option>\r\n\t\t\t\t<mat-option *ngIf=\"parent.qMap.addable && parent.qMap.style != 'inline'\" [value]=\"'add'\">\r\n\t\t\t\t\t<i class=\"fa fa-plus\"></i>\r\n\t\t\t\t\tAdd new {{ parent.qMap.obj_type }}\r\n\t\t\t\t</mat-option>\r\n\t\t\t\t</mat-autocomplete>\r\n\t\t\t</ng-container>\r\n\r\n\t\t</ng-container>\r\n\r\n\r\n\t</ng-container>\r\n</ng-container>\r\n\r\n" }]
        }], ctorParameters: function () {
        return [{ type: QMAPService, decorators: [{
                        type: Inject,
                        args: [forwardRef(() => QMAPService)]
                    }] }];
    } });
class QuestionSimpleComponent extends SubQuestionComponent {
    get htmlVal() {
        return this.localVal;
    }
    set htmlVal(s) {
        this.localVal = s;
        this.applyValue(s);
    }
    constructor() {
        super();
    }
    ngOnInit() {
        if (this.parent.qMap.type == 'json')
            this.localVal = this.parent.val ? JSON.stringify(this.parent.val, null, 2) : null;
        else
            this.localVal = this.parent.val;
        super.ngOnInit();
        /*if(this.parent.qMap.type =='text' && this.parent.qMap.style == 'html'){
            
            this.htmlCfg = {
                
                fileUploadURL: this.V.cfg.host + this.parent.model.urlPath() + '.bin',
                imageUploadURL: this.V.cfg.host + this.parent.model.urlPath() + '.bin',

                // Set request type.
                fileUploadMethod: 'PUT',
                imageUploadMethod: 'PUT',

                requestHeaders:{
                    'Authorization':'Bearer ' + this.V.localSession().access_token
                },

                // Set max file size to 20MB.
                fileMaxSize: 20 * 1024 * 1024,

                // Allow to upload any file.
                fileAllowedTypes: ['*'],
                charCounterCount:false,
                events : {

                    'froalaEditor.image.beforeInsert': (e, editor, link, text, attrs) => {
                        console.log(attrs)
                    },
                        'froalaEditor.image.uploaded' : (e, editor,resp) => {
                            console.log(e);
                        let json = JSON.parse(resp);
                        if(json['status'] < 400){
                            let url = this.V.cfg.host + this.parent.model.urlPath() + '/file'
                            editor.image.insert(url);
                            return false;
                        }
                    }
                }
            }
        }*/
    }
    initValue() {
        super.initValue();
        if (this.parent.qMap.type == 'json' && this.localVal)
            this.localVal = JSON.stringify(this.localVal, null, 2);
        if (this.parent.qMap.type == 'boolean' && this.parent.qMap.inverse) {
            this.localVal = !this.localVal;
        }
    }
    subValues(a) {
        // TODO add sub value logic for onselect of choice and onNeg of check
        super.subValues(a);
        switch (this.parent.qMap.type) {
            //case 'choice':{
            // 	let s = this.parent.qMap.values.find((i)=> i.value == a)
            // 	this.parent.subs = s && s.onSelect? s.onSelect:[]
            // 	break;
            // }
            case 'check': {
                if (this.parent.qMap.onNeg && a == 'false') {
                    this.addSubQuestion(this.parent.qMap.onNeg);
                }
                if (this.parent.qMap.onPos && a == 'true')
                    this.addSubQuestion(this.parent.qMap.onPos);
                if (this.parent.qMap.onWarn && a == 'warn')
                    this.addSubQuestion(this.parent.qMap.onWarn);
                break;
            }
            case 'boolean': {
                if (this.parent.qMap.onNeg && a == false)
                    this.addSubQuestion(this.parent.qMap.onNeg);
                if (this.parent.qMap.onPos && a)
                    this.addSubQuestion(this.parent.qMap.onPos);
                break;
            }
        }
    }
    parentChange(change) {
        if (this.parent.qMap.type == 'json')
            this.localVal = this.parent.val ? JSON.stringify(this.parent.val, null, 2) : null;
        else
            super.parentChange(change);
    }
    supportedTemplates() {
        return [];
    }
    jsParse() {
        return false;
    }
    applyValue(v) {
        // toggle if same option is pressed
        if ((this.parent.qMap.type == 'check') && v == this.localVal) {
            v = null;
        }
        this.localVal = v;
        if (this.parent.qMap.type == 'json') {
            try {
                if (v == '')
                    super.applyValue(null);
                else {
                    let vv = JSON.parse(v);
                    super.applyValue(vv);
                    this.localVal = JSON.stringify(vv, null, 2);
                }
                this.jsonError = null;
            }
            catch (e) {
                this.jsonError = e;
            }
        }
        else if (this.parent.qMap.type == 'boolean' && this.parent.qMap.inverse) {
            super.applyValue(!v);
        }
        else
            super.applyValue(v);
    }
    isValid() {
        if (this.parent.qMap.type == 'boolean') {
            let b = !this.parent.qMap.required || (this.parent.val != null && this.parent.val != undefined);
            this.invalidIcon = 'fa-asterisk';
            if (b) {
                this.invalidColour = null;
                //this.invalidIcon = null
                this.invalidTooltip = null;
            }
            else {
                this.invalidColour = 'text-danger';
                this.invalidTooltip = 'Field is required';
            }
            return b;
        }
        else {
            return super.isValid();
        }
    }
}
/** @nocollapse */ QuestionSimpleComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QuestionSimpleComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
/** @nocollapse */ QuestionSimpleComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.9", type: QuestionSimpleComponent, selector: "tou-simple-question", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"templates['inner_layout']\" [ngTemplateOutlet]=\"templates['inner_layout']\"\r\n        [ngTemplateOutletContext]=\"{localVal:localVal,templates:parent.templates,parent:parent,self:this}\">\r\n</ng-container>\r\n\r\n<ng-container *ngIf=\"!templates['inner_layout']\">\r\n\t<ng-container [ngSwitch]=\"parent.qMap.type\">\r\n\t\t<ng-container *ngSwitchCase=\"'check'\">\r\n\t\t\t<ng-container *ngIf=\"!parent.qMap.style\">\r\n\t\t\t\t\r\n\r\n\t\t\t\t<table *ngIf=\"!parent.lightWeight\" class=\"full-width\" style=\"margin-bottom:10px;\">\r\n\t\t\t\t\t<tr><td colspan=\"2\">{{ parent.qMap.title | qmap_el: parent}} <i *ngIf=\"parent.qMap.required && !localVal\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i></td></tr>\r\n\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t<td><button class=\"full-width\" mat-raised-button [color]=\"localVal == 'true' ? 'accent':'default'\" (click)=\"applyValue('true')\">{{ (parent.qMap.pos || 'Checked') | qmap_el: parent}}</button></td>\r\n\t\t\t\t\t\t\r\n\t\t\t\t\t\t<td *ngIf=\"parent.qMap.warn\" ><button class=\"full-width\" mat-raised-button [color]=\"localVal == 'warn' ? 'warn':'default'\" (click)=\"applyValue('warn')\">{{ parent.qMap.warn }}</button></td>\r\n\t\t\t\t\t\t\r\n\t\t\t\t\t\t<td><button class=\"full-width\" mat-raised-button [color]=\"localVal == 'false' ? 'warn':'default'\"  (click)=\"applyValue('false')\">{{ (parent.qMap.neg || 'Issue') | qmap_el: parent}}</button></td>\r\n\t\t\t\t\t</tr>\r\n\t\t\t\t\t<tr><td colspan=\"2\"><small>{{ parent.qMap.subtitle | qmap_el: parent }}</small></td></tr>\r\n\t\t\t\t</table>\r\n\t\t\t\t\r\n\t\t\t\t\r\n\t\t\t</ng-container> \r\n\t        <mat-checkbox *ngIf=\"parent.qMap.style == 'checkbox'\" name=\"{{ parent.qMap.id }}\" [value]=\"'true'\" [(ngModel)]=\"localBool\" (ngModelChange)=\"applyValue('' + localBool)\" ><span *ngIf=\"!parent.lightWeight\">{{ parent.qMap.title | qmap_el: parent}}</span></mat-checkbox>\r\n\t    </ng-container>\r\n\r\n\t\t<ng-container *ngSwitchCase=\"'boolean'\"> \r\n\t\t\t<table *ngIf=\"parent.qMap.style == 'buttons'\" class=\"full-width\" style=\"margin-bottom:10px;\">\r\n\t\t\t\t\t<tr><td colspan=\"2\">{{ parent.qMap.title | qmap_el: parent}} <i *ngIf=\"parent.qMap.required && (localVal == undefined || localVal == null)\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i></td></tr>\r\n\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t<td><button class=\"full-width\" mat-raised-button [color]=\"localVal ? 'accent':'default'\" (click)=\"applyValue(true)\">{{ (parent.qMap.pos || 'True') | qmap_el: parent}}</button></td>\r\n\t\t\t\t\t\t<td><button class=\"full-width\" mat-raised-button [color]=\"localVal == false ? 'warn':'default'\"  (click)=\"applyValue(false)\">{{ (parent.qMap.neg || 'False') | qmap_el: parent}}</button></td>\r\n\t\t\t\t\t</tr>\r\n\t\t\t\t\t<tr><td colspan=\"2\"><small>{{ parent.qMap.subtitle | qmap_el: parent }}</small></td></tr>\r\n\t\t\t\t</table>\r\n\r\n\t         <mat-checkbox [disabled]=\"parent.qMap.disabled\" *ngIf=\"parent.qMap.style != 'buttons'\" name=\"{{ parent.qMap.id }}\" value=\"true\" [(ngModel)]=\"localVal\" (ngModelChange)=\"applyValue(localVal)\" ><span *ngIf=\"!parent.lightWeight\">{{ parent.qMap.title | qmap_el: parent}}</span></mat-checkbox>\r\n\t    </ng-container>\r\n\t   \r\n\r\n\t\t<ng-container *ngSwitchCase=\"'text'\"> \r\n\t    \t\r\n\t    \t<!-- <div *ngIf=\"parent.qMap.style == 'html'\" [froalaEditor]=\"htmlCfg\" [(froalaModel)]=\"htmlVal\"></div> -->\r\n\t    \t<div *ngIf=\"parent.qMap.style != 'html'\">\r\n\t\t\t\t<mat-form-field *ngIf=\"!parent.lightWeight\" class=\"full-width\" [appearance]=\"parent.appearance\">\r\n\t\t\t\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t\t            <textarea \r\n\t\t             \t[disabled]=\"parent.qMap.disabled\" \r\n\t\t            \t[name]=\"parent.qMap.id\"\r\n\t\t            \tmatInput [placeholder]=\"parent.qMap.title | qmap_el: parent\" \r\n\t\t\t\t\t\tname=\"{{ parent.qMap.name }}\" \r\n\t\t\t\t\t\t[(ngModel)]=\"localVal\" \r\n\t\t\t\t\t\t(blur)=\"applyValue(localVal)\" \r\n\t\t\t\t\t\trows=\"3\"\r\n\t\t\t\t\t\t[required]=\"parent.qMap.required\"></textarea>\r\n\t\t            <mat-hint *ngIf=\"parent.qMap.subtitle\" align=\"end\">{{ parent.qMap.subtitle  | qmap_el: parent }}</mat-hint>\r\n\t\t            <i *ngIf=\"parent.qMap.required\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\t\t\t\t\t<mat-error *ngIf=\"parent.qMap.required\">Field Required</mat-error >\r\n\t\t        </mat-form-field>\r\n\r\n\t\t        <textarea *ngIf=\"parent.lightWeight\" matInput [name]=\"parent.qMap.id\" class=\"lightweight\" [(ngModel)]=\"localVal\" (blur)=\"applyValue($event)\" rows=\"3\"></textarea>\r\n\t        </div>\r\n\t\t</ng-container>\r\n\r\n\r\n\t\t<ng-container *ngSwitchCase=\"'qr'\"> \r\n\t    \t\r\n\t    \t<!-- <div *ngIf=\"parent.qMap.style == 'html'\" [froalaEditor]=\"htmlCfg\" [(froalaModel)]=\"htmlVal\"></div> -->\r\n\t    \t<div *ngIf=\"parent.qMap.style != 'html'\">\r\n\t\t\t\t<mat-form-field *ngIf=\"!parent.lightWeight\" class=\"full-width\" [appearance]=\"parent.appearance\">\r\n\t\t\t\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t\t            <textarea \r\n\t\t\t\t\t\t[disabled]=\"parent.qMap.disabled\" \r\n\t\t            \t[name]=\"parent.qMap.id\"\r\n\t\t            \tmatInput [placeholder]=\"parent.qMap.title | qmap_el: parent\" \r\n\t\t\t\t\t\tname=\"{{ parent.qMap.name }}\" \r\n\t\t\t\t\t\t[(ngModel)]=\"localVal\"  \r\n\t\t\t\t\t\t(blur)=\"applyValue(localVal)\"  \r\n\t\t\t\t\t\trows=\"3\"\r\n\t\t\t\t\t\t[required]=\"parent.qMap.required\"></textarea>\r\n\t\t            <mat-hint *ngIf=\"parent.qMap.subtitle\" align=\"end\">{{ parent.qMap.subtitle  | qmap_el: parent }}</mat-hint>\r\n\t\t            <i *ngIf=\"parent.qMap.required\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\t\t\t\t\t<mat-error *ngIf=\"parent.qMap.required\">Field Required</mat-error >\r\n\t\t        </mat-form-field>\r\n\r\n\t\t        <textarea *ngIf=\"parent.lightWeight\" matInput [name]=\"parent.qMap.id\" class=\"lightweight\" [(ngModel)]=\"localVal\" (blur)=\"applyValue($event)\" rows=\"3\"></textarea>\r\n\t        </div>\r\n\t\t</ng-container>\r\n\t\t\r\n\t\t<ng-container *ngSwitchCase=\"'json'\"> \r\n\t    \t\r\n\t    \t\r\n\t\t\t<mat-form-field  *ngIf=\"!parent.lightWeight\" class=\"full-width\" [appearance]=\"parent.appearance\">\r\n\t\t\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t\t\t\t<textarea \r\n\t\t\t\t\t[disabled]=\"parent.qMap.disabled\" \r\n\t\t\t\t\t[name]=\"parent.qMap.id\"\r\n\t\t\t\t\tmatInput [placeholder]=\"parent.qMap.title | qmap_el: parent\" \r\n\t\t\t\t\tname=\"{{ parent.qMap.name }}\" \r\n\t\t\t\t\t[(ngModel)]=\"localVal\" \r\n\t\t\t\t\t(blur)=\"applyValue(localVal)\" \r\n\t\t\t\t\trows=\"5\"\r\n\t\t\t\t\t[required]=\"parent.qMap.required\"></textarea>\r\n\t\t\t\t<mat-hint *ngIf=\"parent.qMap.subtitle\" align=\"end\">{{ parent.qMap.subtitle  | qmap_el: parent }}</mat-hint>\r\n\t\t\t\t<mat-hint *ngIf=\"jsonError\" align=\"end\">Invalid JSON {{ jsonError }}</mat-hint>\r\n\t\t\t\t<i *ngIf=\"parent.qMap.required\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\t\t\t\t<mat-error *ngIf=\"parent.qMap.required\">Field Required</mat-error >\r\n\t\t\t</mat-form-field>\r\n\r\n\t\t\t<textarea *ngIf=\"parent.lightWeight\" matInput [name]=\"parent.qMap.id\" class=\"lightweight\" [(ngModel)]=\"localVal\" (blur)=\"applyValue($event)\" rows=\"5\"></textarea>\r\n\t        \r\n\t\t</ng-container>\r\n\r\n\t\t<ng-container *ngSwitchCase=\"'number'\"> \r\n\t    \r\n\t\t\t<mat-form-field *ngIf=\"!parent.lightWeight\" class=\"full-width\" [appearance]=\"parent.appearance\">\r\n\t\t\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t            <input type=\"number\" [disabled]=\"parent.qMap.disabled\"  matInput [name]=\"parent.qMap.id\" [placeholder]=\"parent.qMap.title | qmap_el: parent \"  [(ngModel)]=\"localVal\"  (blur)=\"applyValue(localVal)\" [required]=\"parent.qMap.required\"  [max]=\"parent.qMap.max || 1000000\" [min]=\"parent.qMap.min || -1000000\"/>\r\n\t            <mat-hint *ngIf=\"parent.qMap.subtitle\" align=\"end\">{{ parent.qMap.subtitle | qmap_el: parent }}</mat-hint>\r\n\t\t\t\t<i *ngIf=\"parent.qMap.required\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\t\t\t\t<mat-error *ngIf=\"parent.qMap.required\">Field Required</mat-error >\r\n\t        </mat-form-field>\r\n\r\n\t        <input *ngIf=\"parent.lightWeight\"  [disabled]=\"parent.qMap.disabled\"  type=\"number\" matInput name=\"{{ parent.qMap.id }}\" class=\"lightweight\" [(ngModel)]=\"localVal\" (blur)=\"applyValue(localVal)\" />\r\n\t\t</ng-container>\r\n\r\n\r\n\t\t<ng-container *ngSwitchDefault> \r\n\t    \t<mat-form-field *ngIf=\"!parent.lightWeight\" class=\"full-width\" [floatLabel]=\"parent.qMap.float || 'auto'\" [appearance]=\"parent.appearance\">\r\n\t\t\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t            <input  #power=\"ngModel\"  [disabled]=\"parent.qMap.disabled\"  matInput \r\n\t\t            [placeholder]=\"( parent.qMap.title || parent.qMap.id )| qmap_el: parent\" \r\n\t\t            [name]=\"parent.qMap.id\" \r\n\t\t            [type]=\"parent.qMap.style|| 'text'\"\r\n\t\t            [(ngModel)]=\"localVal\"  \r\n\t\t            (blur)=\"applyValue(localVal)\" [required]=\"parent.qMap.required\"\r\n\t\t         />\r\n\t            <mat-error *ngIf=\"parent.qMap.required\">Field Required</mat-error >\r\n\t\t        <i *ngIf=\"parent.qMap.required\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\t            <mat-hint *ngIf=\"parent.qMap.subtitle\" align=\"end\">{{ parent.qMap.subtitle | qmap_el: parent }}</mat-hint>\r\n\t        </mat-form-field>\r\n\r\n\t        <input *ngIf=\"parent.lightWeight\"\r\n\t\t         matInput  [disabled]=\"parent.qMap.disabled\"  [name]=\"parent.qMap.id\" \r\n\t\t         class=\"lightweight\" \r\n\t\t         [(ngModel)]=\"localVal\" \r\n\t\t        \r\n\t\t         (blur)=\"applyValue(localVal)\" />\r\n\t\t</ng-container>\r\n\r\n\t</ng-container>\r\n</ng-container>\r\n", dependencies: [{ kind: "directive", type: i0.forwardRef(function () { return i3.NgIf; }), selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgTemplateOutlet; }), selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgSwitch; }), selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgSwitchCase; }), selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgSwitchDefault; }), selector: "[ngSwitchDefault]" }, { kind: "directive", type: i0.forwardRef(function () { return i7.DefaultValueAccessor; }), selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i0.forwardRef(function () { return i7.NumberValueAccessor; }), selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i0.forwardRef(function () { return i7.NgControlStatus; }), selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i0.forwardRef(function () { return i7.RequiredValidator; }), selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i0.forwardRef(function () { return i7.MinValidator; }), selector: "input[type=number][min][formControlName],input[type=number][min][formControl],input[type=number][min][ngModel]", inputs: ["min"] }, { kind: "directive", type: i0.forwardRef(function () { return i7.MaxValidator; }), selector: "input[type=number][max][formControlName],input[type=number][max][formControl],input[type=number][max][ngModel]", inputs: ["max"] }, { kind: "directive", type: i0.forwardRef(function () { return i7.NgModel; }), selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i0.forwardRef(function () { return i10.MatFormField; }), selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i0.forwardRef(function () { return i10.MatLabel; }), selector: "mat-label" }, { kind: "directive", type: i0.forwardRef(function () { return i10.MatHint; }), selector: "mat-hint", inputs: ["align", "id"] }, { kind: "directive", type: i0.forwardRef(function () { return i10.MatError; }), selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i0.forwardRef(function () { return i10.MatSuffix; }), selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "component", type: i0.forwardRef(function () { return i15.MatButton; }), selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "component", type: i0.forwardRef(function () { return i16.MatCheckbox; }), selector: "mat-checkbox", inputs: ["disableRipple", "color", "tabIndex"], exportAs: ["matCheckbox"] }, { kind: "directive", type: i0.forwardRef(function () { return i13.MatInput; }), selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "directive", type: i0.forwardRef(function () { return i14.MatTooltip; }), selector: "[matTooltip]", exportAs: ["matTooltip"] }, { kind: "pipe", type: i0.forwardRef(function () { return QMAPExpressionLanguage; }), name: "qmap_el" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QuestionSimpleComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tou-simple-question', template: "<ng-container *ngIf=\"templates['inner_layout']\" [ngTemplateOutlet]=\"templates['inner_layout']\"\r\n        [ngTemplateOutletContext]=\"{localVal:localVal,templates:parent.templates,parent:parent,self:this}\">\r\n</ng-container>\r\n\r\n<ng-container *ngIf=\"!templates['inner_layout']\">\r\n\t<ng-container [ngSwitch]=\"parent.qMap.type\">\r\n\t\t<ng-container *ngSwitchCase=\"'check'\">\r\n\t\t\t<ng-container *ngIf=\"!parent.qMap.style\">\r\n\t\t\t\t\r\n\r\n\t\t\t\t<table *ngIf=\"!parent.lightWeight\" class=\"full-width\" style=\"margin-bottom:10px;\">\r\n\t\t\t\t\t<tr><td colspan=\"2\">{{ parent.qMap.title | qmap_el: parent}} <i *ngIf=\"parent.qMap.required && !localVal\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i></td></tr>\r\n\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t<td><button class=\"full-width\" mat-raised-button [color]=\"localVal == 'true' ? 'accent':'default'\" (click)=\"applyValue('true')\">{{ (parent.qMap.pos || 'Checked') | qmap_el: parent}}</button></td>\r\n\t\t\t\t\t\t\r\n\t\t\t\t\t\t<td *ngIf=\"parent.qMap.warn\" ><button class=\"full-width\" mat-raised-button [color]=\"localVal == 'warn' ? 'warn':'default'\" (click)=\"applyValue('warn')\">{{ parent.qMap.warn }}</button></td>\r\n\t\t\t\t\t\t\r\n\t\t\t\t\t\t<td><button class=\"full-width\" mat-raised-button [color]=\"localVal == 'false' ? 'warn':'default'\"  (click)=\"applyValue('false')\">{{ (parent.qMap.neg || 'Issue') | qmap_el: parent}}</button></td>\r\n\t\t\t\t\t</tr>\r\n\t\t\t\t\t<tr><td colspan=\"2\"><small>{{ parent.qMap.subtitle | qmap_el: parent }}</small></td></tr>\r\n\t\t\t\t</table>\r\n\t\t\t\t\r\n\t\t\t\t\r\n\t\t\t</ng-container> \r\n\t        <mat-checkbox *ngIf=\"parent.qMap.style == 'checkbox'\" name=\"{{ parent.qMap.id }}\" [value]=\"'true'\" [(ngModel)]=\"localBool\" (ngModelChange)=\"applyValue('' + localBool)\" ><span *ngIf=\"!parent.lightWeight\">{{ parent.qMap.title | qmap_el: parent}}</span></mat-checkbox>\r\n\t    </ng-container>\r\n\r\n\t\t<ng-container *ngSwitchCase=\"'boolean'\"> \r\n\t\t\t<table *ngIf=\"parent.qMap.style == 'buttons'\" class=\"full-width\" style=\"margin-bottom:10px;\">\r\n\t\t\t\t\t<tr><td colspan=\"2\">{{ parent.qMap.title | qmap_el: parent}} <i *ngIf=\"parent.qMap.required && (localVal == undefined || localVal == null)\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i></td></tr>\r\n\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t<td><button class=\"full-width\" mat-raised-button [color]=\"localVal ? 'accent':'default'\" (click)=\"applyValue(true)\">{{ (parent.qMap.pos || 'True') | qmap_el: parent}}</button></td>\r\n\t\t\t\t\t\t<td><button class=\"full-width\" mat-raised-button [color]=\"localVal == false ? 'warn':'default'\"  (click)=\"applyValue(false)\">{{ (parent.qMap.neg || 'False') | qmap_el: parent}}</button></td>\r\n\t\t\t\t\t</tr>\r\n\t\t\t\t\t<tr><td colspan=\"2\"><small>{{ parent.qMap.subtitle | qmap_el: parent }}</small></td></tr>\r\n\t\t\t\t</table>\r\n\r\n\t         <mat-checkbox [disabled]=\"parent.qMap.disabled\" *ngIf=\"parent.qMap.style != 'buttons'\" name=\"{{ parent.qMap.id }}\" value=\"true\" [(ngModel)]=\"localVal\" (ngModelChange)=\"applyValue(localVal)\" ><span *ngIf=\"!parent.lightWeight\">{{ parent.qMap.title | qmap_el: parent}}</span></mat-checkbox>\r\n\t    </ng-container>\r\n\t   \r\n\r\n\t\t<ng-container *ngSwitchCase=\"'text'\"> \r\n\t    \t\r\n\t    \t<!-- <div *ngIf=\"parent.qMap.style == 'html'\" [froalaEditor]=\"htmlCfg\" [(froalaModel)]=\"htmlVal\"></div> -->\r\n\t    \t<div *ngIf=\"parent.qMap.style != 'html'\">\r\n\t\t\t\t<mat-form-field *ngIf=\"!parent.lightWeight\" class=\"full-width\" [appearance]=\"parent.appearance\">\r\n\t\t\t\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t\t            <textarea \r\n\t\t             \t[disabled]=\"parent.qMap.disabled\" \r\n\t\t            \t[name]=\"parent.qMap.id\"\r\n\t\t            \tmatInput [placeholder]=\"parent.qMap.title | qmap_el: parent\" \r\n\t\t\t\t\t\tname=\"{{ parent.qMap.name }}\" \r\n\t\t\t\t\t\t[(ngModel)]=\"localVal\" \r\n\t\t\t\t\t\t(blur)=\"applyValue(localVal)\" \r\n\t\t\t\t\t\trows=\"3\"\r\n\t\t\t\t\t\t[required]=\"parent.qMap.required\"></textarea>\r\n\t\t            <mat-hint *ngIf=\"parent.qMap.subtitle\" align=\"end\">{{ parent.qMap.subtitle  | qmap_el: parent }}</mat-hint>\r\n\t\t            <i *ngIf=\"parent.qMap.required\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\t\t\t\t\t<mat-error *ngIf=\"parent.qMap.required\">Field Required</mat-error >\r\n\t\t        </mat-form-field>\r\n\r\n\t\t        <textarea *ngIf=\"parent.lightWeight\" matInput [name]=\"parent.qMap.id\" class=\"lightweight\" [(ngModel)]=\"localVal\" (blur)=\"applyValue($event)\" rows=\"3\"></textarea>\r\n\t        </div>\r\n\t\t</ng-container>\r\n\r\n\r\n\t\t<ng-container *ngSwitchCase=\"'qr'\"> \r\n\t    \t\r\n\t    \t<!-- <div *ngIf=\"parent.qMap.style == 'html'\" [froalaEditor]=\"htmlCfg\" [(froalaModel)]=\"htmlVal\"></div> -->\r\n\t    \t<div *ngIf=\"parent.qMap.style != 'html'\">\r\n\t\t\t\t<mat-form-field *ngIf=\"!parent.lightWeight\" class=\"full-width\" [appearance]=\"parent.appearance\">\r\n\t\t\t\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t\t            <textarea \r\n\t\t\t\t\t\t[disabled]=\"parent.qMap.disabled\" \r\n\t\t            \t[name]=\"parent.qMap.id\"\r\n\t\t            \tmatInput [placeholder]=\"parent.qMap.title | qmap_el: parent\" \r\n\t\t\t\t\t\tname=\"{{ parent.qMap.name }}\" \r\n\t\t\t\t\t\t[(ngModel)]=\"localVal\"  \r\n\t\t\t\t\t\t(blur)=\"applyValue(localVal)\"  \r\n\t\t\t\t\t\trows=\"3\"\r\n\t\t\t\t\t\t[required]=\"parent.qMap.required\"></textarea>\r\n\t\t            <mat-hint *ngIf=\"parent.qMap.subtitle\" align=\"end\">{{ parent.qMap.subtitle  | qmap_el: parent }}</mat-hint>\r\n\t\t            <i *ngIf=\"parent.qMap.required\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\t\t\t\t\t<mat-error *ngIf=\"parent.qMap.required\">Field Required</mat-error >\r\n\t\t        </mat-form-field>\r\n\r\n\t\t        <textarea *ngIf=\"parent.lightWeight\" matInput [name]=\"parent.qMap.id\" class=\"lightweight\" [(ngModel)]=\"localVal\" (blur)=\"applyValue($event)\" rows=\"3\"></textarea>\r\n\t        </div>\r\n\t\t</ng-container>\r\n\t\t\r\n\t\t<ng-container *ngSwitchCase=\"'json'\"> \r\n\t    \t\r\n\t    \t\r\n\t\t\t<mat-form-field  *ngIf=\"!parent.lightWeight\" class=\"full-width\" [appearance]=\"parent.appearance\">\r\n\t\t\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t\t\t\t<textarea \r\n\t\t\t\t\t[disabled]=\"parent.qMap.disabled\" \r\n\t\t\t\t\t[name]=\"parent.qMap.id\"\r\n\t\t\t\t\tmatInput [placeholder]=\"parent.qMap.title | qmap_el: parent\" \r\n\t\t\t\t\tname=\"{{ parent.qMap.name }}\" \r\n\t\t\t\t\t[(ngModel)]=\"localVal\" \r\n\t\t\t\t\t(blur)=\"applyValue(localVal)\" \r\n\t\t\t\t\trows=\"5\"\r\n\t\t\t\t\t[required]=\"parent.qMap.required\"></textarea>\r\n\t\t\t\t<mat-hint *ngIf=\"parent.qMap.subtitle\" align=\"end\">{{ parent.qMap.subtitle  | qmap_el: parent }}</mat-hint>\r\n\t\t\t\t<mat-hint *ngIf=\"jsonError\" align=\"end\">Invalid JSON {{ jsonError }}</mat-hint>\r\n\t\t\t\t<i *ngIf=\"parent.qMap.required\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\t\t\t\t<mat-error *ngIf=\"parent.qMap.required\">Field Required</mat-error >\r\n\t\t\t</mat-form-field>\r\n\r\n\t\t\t<textarea *ngIf=\"parent.lightWeight\" matInput [name]=\"parent.qMap.id\" class=\"lightweight\" [(ngModel)]=\"localVal\" (blur)=\"applyValue($event)\" rows=\"5\"></textarea>\r\n\t        \r\n\t\t</ng-container>\r\n\r\n\t\t<ng-container *ngSwitchCase=\"'number'\"> \r\n\t    \r\n\t\t\t<mat-form-field *ngIf=\"!parent.lightWeight\" class=\"full-width\" [appearance]=\"parent.appearance\">\r\n\t\t\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t            <input type=\"number\" [disabled]=\"parent.qMap.disabled\"  matInput [name]=\"parent.qMap.id\" [placeholder]=\"parent.qMap.title | qmap_el: parent \"  [(ngModel)]=\"localVal\"  (blur)=\"applyValue(localVal)\" [required]=\"parent.qMap.required\"  [max]=\"parent.qMap.max || 1000000\" [min]=\"parent.qMap.min || -1000000\"/>\r\n\t            <mat-hint *ngIf=\"parent.qMap.subtitle\" align=\"end\">{{ parent.qMap.subtitle | qmap_el: parent }}</mat-hint>\r\n\t\t\t\t<i *ngIf=\"parent.qMap.required\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\t\t\t\t<mat-error *ngIf=\"parent.qMap.required\">Field Required</mat-error >\r\n\t        </mat-form-field>\r\n\r\n\t        <input *ngIf=\"parent.lightWeight\"  [disabled]=\"parent.qMap.disabled\"  type=\"number\" matInput name=\"{{ parent.qMap.id }}\" class=\"lightweight\" [(ngModel)]=\"localVal\" (blur)=\"applyValue(localVal)\" />\r\n\t\t</ng-container>\r\n\r\n\r\n\t\t<ng-container *ngSwitchDefault> \r\n\t    \t<mat-form-field *ngIf=\"!parent.lightWeight\" class=\"full-width\" [floatLabel]=\"parent.qMap.float || 'auto'\" [appearance]=\"parent.appearance\">\r\n\t\t\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t            <input  #power=\"ngModel\"  [disabled]=\"parent.qMap.disabled\"  matInput \r\n\t\t            [placeholder]=\"( parent.qMap.title || parent.qMap.id )| qmap_el: parent\" \r\n\t\t            [name]=\"parent.qMap.id\" \r\n\t\t            [type]=\"parent.qMap.style|| 'text'\"\r\n\t\t            [(ngModel)]=\"localVal\"  \r\n\t\t            (blur)=\"applyValue(localVal)\" [required]=\"parent.qMap.required\"\r\n\t\t         />\r\n\t            <mat-error *ngIf=\"parent.qMap.required\">Field Required</mat-error >\r\n\t\t        <i *ngIf=\"parent.qMap.required\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\t            <mat-hint *ngIf=\"parent.qMap.subtitle\" align=\"end\">{{ parent.qMap.subtitle | qmap_el: parent }}</mat-hint>\r\n\t        </mat-form-field>\r\n\r\n\t        <input *ngIf=\"parent.lightWeight\"\r\n\t\t         matInput  [disabled]=\"parent.qMap.disabled\"  [name]=\"parent.qMap.id\" \r\n\t\t         class=\"lightweight\" \r\n\t\t         [(ngModel)]=\"localVal\" \r\n\t\t        \r\n\t\t         (blur)=\"applyValue(localVal)\" />\r\n\t\t</ng-container>\r\n\r\n\t</ng-container>\r\n</ng-container>\r\n" }]
        }], ctorParameters: function () { return []; } });
class QuestionChoiceComponent extends QuestionSimpleComponent {
    constructor(service) {
        super();
        this.service = service;
        this.myControl = new FormControl();
    }
    ngOnInit() {
        this.myControl.valueChanges
            .pipe(debounceTime(500), flatMap(s => {
            if (this.parent.qMap.style == 'combo')
                this.values = this.filterValues(s);
            else
                this.values = this.filterValues();
            return this.values.pipe(map(items => [items, s]));
        })).subscribe(array => {
            let f = array[0].find(i => i.value == array[1]);
            var lo = f || { value: array[1] };
            if (lo) {
                this.selectVal(lo);
            }
        });
        super.ngOnInit();
    }
    initValue() {
        super.initValue();
        this.values = this.filterValues(this.localVal);
        if (this.localVal) {
            this.myControl.setValue(this.localVal);
        }
    }
    filterValues(search) {
        search = search && typeof search == 'string' ? search.toLowerCase() : search;
        if (this.parent.qMap.useSource) {
            return this.service.objectsForQMap(this.parent.qMap, search, this.parent.superModel()).pipe(map(items => items.map(i => {
                return this.parent.qMap.useSource.value ?
                    // pull the fields specificed by config
                    { value: i[this.parent.qMap.useSource.value], title: this.parent.qMap.useSource.title ? i[this.parent.qMap.useSource.title] : i[this.parent.qMap.useSource.value] } :
                    // just use object's name
                    { value: i.name, title: i.name };
            })));
        }
        else {
            return of(this.parent.qMap.values).pipe(map(items => {
                if (search && search.length) {
                    let vv = items.filter(v => (v.title && v.title.toLowerCase().indexOf(search) != -1) ||
                        (v.value && typeof v.value == 'string' && v.value.toLowerCase().indexOf(search) != -1));
                    return vv;
                }
                else
                    return items;
            }));
        }
    }
    parentChange(change) {
        console.log(change);
        super.parentChange(change);
        this.myControl.setValue(this.localVal);
    }
    selectValViaPulldown(e) {
        if (this.parent.qMap.values) {
            let v = this.parent.qMap.values.find(qm => qm.value == e.value);
            if (v) {
                this.selectVal(v);
                return;
            }
        }
        // just pass {value:'str'}
        this.selectVal(e);
    }
    selectVal(e) {
        let v = e ? (e.value ? e : (e.option ? e.option.value : null)) : null;
        if (this.localObj != v) {
            this.localObj = v;
            this.applyValue(v ? v.value : null);
        }
        // if theres a value still run the submenus
        else if (this.localObj && this.localObj.onSelect) {
            this.parent.subs = [];
            this.addSubQuestion(this.localObj.onSelect);
        }
        if (this.parent.qMap.storeTitle && v && v.title)
            this.parent.model[this.parent.qMap.id + '_title'] = v.title;
    }
    subValues(a) {
        super.subValues(a);
        if (this.localObj && this.localObj.onSelect) {
            this.parent.subs = [];
            this.addSubQuestion(this.localObj.onSelect);
        }
    }
    displayWith(e) {
        return e ? (e.title || e.value) : null;
    }
}
/** @nocollapse */ QuestionChoiceComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QuestionChoiceComponent, deps: [{ token: forwardRef(() => QMAPService) }], target: i0.ɵɵFactoryTarget.Component });
/** @nocollapse */ QuestionChoiceComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.9", type: QuestionChoiceComponent, selector: "tou-choice-question,[tou-choice-question]", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"templates['inner_layout']\" [ngTemplateOutlet]=\"templates['inner_layout']\"\r\n        [ngTemplateOutletContext]=\"{localVal:localVal,templates:parent.templates,parent:parent,self:this}\">\r\n</ng-container>\r\n\r\n<ng-container *ngIf=\"!templates['inner_layout']\">\r\n<ng-container *ngIf=\"parent.qMap.style == 'pulldown' || parent.qMap.style == 'combo' || (!parent.qMap.style && parent.qMap.values && parent.qMap.values?.length > 4)\">\r\n\t<mat-form-field *ngIf=\"parent.qMap.style == 'combo'\" class=\"full-width\"  [floatLabel]=\"parent.qMap.float || 'auto'\" [appearance]=\"parent.appearance\">\r\n\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t\t<input type=\"text\" matInput [disabled]=\"parent.qMap.disabled\" [placeholder]=\"parent.qMap.title | qmap_el: parent \"  [matAutocomplete]=\"myPulldown\" [formControl]=\"myControl\"/>\r\n\r\n\t    <mat-hint *ngIf=\"parent.qMap.subtitle\" align=\"end\">{{ parent.qMap.subtitle | qmap_el: parent }}</mat-hint>\r\n\r\n\t    <i *ngIf=\"parent.qMap.required\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\r\n\t    <i class=\"fa fa-caret-down\"  matSuffix></i>\r\n\t\t<mat-autocomplete #myPulldown=\"matAutocomplete\">\r\n\t\t   <mat-option *ngFor=\"let item of values | async\" [value]=\"item.value\">{{ item.title || item.value }}</mat-option>\r\n\t\t</mat-autocomplete>\r\n\t</mat-form-field>\r\n\r\n\t<mat-form-field *ngIf=\"parent.qMap.style != 'combo'\" class=\"full-width\"  [floatLabel]=\"parent.qMap.float || 'auto'\" [appearance]=\"parent.appearance\">\r\n\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t\t<mat-select [disabled]=\"parent.qMap.disabled\" [placeholder]=\"parent.qMap.title | qmap_el: parent \" [(ngModel)]=\"localVal\"  [required]=\"parent.qMap.required\" (selectionChange)=\"selectValViaPulldown($event)\" [multiple]=\"parent.qMap.multi\">\r\n\t\t    <mat-option *ngFor=\"let cur of values | async\" [value]=\"cur.value\">\r\n\t\t      {{ cur.title || cur.value }}\r\n\t\t    </mat-option>\r\n\t\t</mat-select>\r\n\t\t<mat-error *ngIf=\"parent.qMap.required\">Field Required</mat-error >\r\n\t\t<i *ngIf=\"parent.qMap.required\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\t\t<i *ngIf=\"parent.qMap.subtitle\" align=\"end\">{{ parent.qMap.subtitle | qmap_el: parent }}</i>\r\n\t</mat-form-field>\r\n</ng-container>\r\n\r\n\r\n<ng-container *ngIf=\"!parent.lightWeight && (parent.qMap.style == 'buttons' || (!parent.qMap.style && parent.qMap.values && parent.qMap.values?.length <= 4))\">\r\n\t<div><h3>{{ parent.qMap.title | qmap_el:parent}}</h3> <i *ngIf=\"parent.qMap.required && !localVal\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i></div>\r\n\t<table class=\"full-width\">\r\n\t\t<tr>\r\n\t\t\t<td *ngFor=\"let cur of values | async\">\r\n\t\t\t\t<button  class=\"full-width\" mat-raised-button  (click)=\"selectVal(cur)\" [color]=\"localVal == cur.value? 'primary':'default'\">{{ cur.title || cur.value }}</button>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr><td colspan=\"2\"><small>{{ parent.qMap.subtitle | qmap_el: parent }}</small></td></tr>\r\n\t</table>\r\n</ng-container>\r\n\r\n<ng-container *ngIf=\"parent.lightWeight && (parent.qMap.style == 'buttons' || (!parent.qMap.style && parent.qMap.values && parent.qMap.values?.length <= 4))\" class=\"full-width\">\r\n\t<ng-container *ngFor=\"let cur of values | async\">\r\n\t\t\t<button  mat-raised-button  (click)=\"selectVal(cur)\" [color]=\"localVal == cur.value? 'primary':'default'\">{{ cur.title || cur.value }}</button>\r\n\t\t</ng-container>\r\n</ng-container>\r\n\r\n</ng-container>", dependencies: [{ kind: "directive", type: i0.forwardRef(function () { return i3.NgForOf; }), selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgIf; }), selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgTemplateOutlet; }), selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i0.forwardRef(function () { return i7.DefaultValueAccessor; }), selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i0.forwardRef(function () { return i7.NgControlStatus; }), selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i0.forwardRef(function () { return i7.RequiredValidator; }), selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i0.forwardRef(function () { return i7.NgModel; }), selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: i0.forwardRef(function () { return i7.FormControlDirective; }), selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: i0.forwardRef(function () { return i8.MatAutocomplete; }), selector: "mat-autocomplete", inputs: ["disableRipple", "hideSingleSelectionIndicator"], exportAs: ["matAutocomplete"] }, { kind: "component", type: i0.forwardRef(function () { return i9.MatOption; }), selector: "mat-option", exportAs: ["matOption"] }, { kind: "directive", type: i0.forwardRef(function () { return i8.MatAutocompleteTrigger; }), selector: "input[matAutocomplete], textarea[matAutocomplete]", exportAs: ["matAutocompleteTrigger"] }, { kind: "component", type: i0.forwardRef(function () { return i10.MatFormField; }), selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i0.forwardRef(function () { return i10.MatLabel; }), selector: "mat-label" }, { kind: "directive", type: i0.forwardRef(function () { return i10.MatHint; }), selector: "mat-hint", inputs: ["align", "id"] }, { kind: "directive", type: i0.forwardRef(function () { return i10.MatError; }), selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i0.forwardRef(function () { return i10.MatSuffix; }), selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "component", type: i0.forwardRef(function () { return i11.MatSelect; }), selector: "mat-select", inputs: ["disabled", "disableRipple", "tabIndex", "hideSingleSelectionIndicator"], exportAs: ["matSelect"] }, { kind: "component", type: i0.forwardRef(function () { return i15.MatButton; }), selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "directive", type: i0.forwardRef(function () { return i13.MatInput; }), selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "directive", type: i0.forwardRef(function () { return i14.MatTooltip; }), selector: "[matTooltip]", exportAs: ["matTooltip"] }, { kind: "pipe", type: i0.forwardRef(function () { return i3.AsyncPipe; }), name: "async" }, { kind: "pipe", type: i0.forwardRef(function () { return QMAPExpressionLanguage; }), name: "qmap_el" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QuestionChoiceComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tou-choice-question,[tou-choice-question]', template: "<ng-container *ngIf=\"templates['inner_layout']\" [ngTemplateOutlet]=\"templates['inner_layout']\"\r\n        [ngTemplateOutletContext]=\"{localVal:localVal,templates:parent.templates,parent:parent,self:this}\">\r\n</ng-container>\r\n\r\n<ng-container *ngIf=\"!templates['inner_layout']\">\r\n<ng-container *ngIf=\"parent.qMap.style == 'pulldown' || parent.qMap.style == 'combo' || (!parent.qMap.style && parent.qMap.values && parent.qMap.values?.length > 4)\">\r\n\t<mat-form-field *ngIf=\"parent.qMap.style == 'combo'\" class=\"full-width\"  [floatLabel]=\"parent.qMap.float || 'auto'\" [appearance]=\"parent.appearance\">\r\n\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t\t<input type=\"text\" matInput [disabled]=\"parent.qMap.disabled\" [placeholder]=\"parent.qMap.title | qmap_el: parent \"  [matAutocomplete]=\"myPulldown\" [formControl]=\"myControl\"/>\r\n\r\n\t    <mat-hint *ngIf=\"parent.qMap.subtitle\" align=\"end\">{{ parent.qMap.subtitle | qmap_el: parent }}</mat-hint>\r\n\r\n\t    <i *ngIf=\"parent.qMap.required\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\r\n\t    <i class=\"fa fa-caret-down\"  matSuffix></i>\r\n\t\t<mat-autocomplete #myPulldown=\"matAutocomplete\">\r\n\t\t   <mat-option *ngFor=\"let item of values | async\" [value]=\"item.value\">{{ item.title || item.value }}</mat-option>\r\n\t\t</mat-autocomplete>\r\n\t</mat-form-field>\r\n\r\n\t<mat-form-field *ngIf=\"parent.qMap.style != 'combo'\" class=\"full-width\"  [floatLabel]=\"parent.qMap.float || 'auto'\" [appearance]=\"parent.appearance\">\r\n\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t\t<mat-select [disabled]=\"parent.qMap.disabled\" [placeholder]=\"parent.qMap.title | qmap_el: parent \" [(ngModel)]=\"localVal\"  [required]=\"parent.qMap.required\" (selectionChange)=\"selectValViaPulldown($event)\" [multiple]=\"parent.qMap.multi\">\r\n\t\t    <mat-option *ngFor=\"let cur of values | async\" [value]=\"cur.value\">\r\n\t\t      {{ cur.title || cur.value }}\r\n\t\t    </mat-option>\r\n\t\t</mat-select>\r\n\t\t<mat-error *ngIf=\"parent.qMap.required\">Field Required</mat-error >\r\n\t\t<i *ngIf=\"parent.qMap.required\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\t\t<i *ngIf=\"parent.qMap.subtitle\" align=\"end\">{{ parent.qMap.subtitle | qmap_el: parent }}</i>\r\n\t</mat-form-field>\r\n</ng-container>\r\n\r\n\r\n<ng-container *ngIf=\"!parent.lightWeight && (parent.qMap.style == 'buttons' || (!parent.qMap.style && parent.qMap.values && parent.qMap.values?.length <= 4))\">\r\n\t<div><h3>{{ parent.qMap.title | qmap_el:parent}}</h3> <i *ngIf=\"parent.qMap.required && !localVal\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i></div>\r\n\t<table class=\"full-width\">\r\n\t\t<tr>\r\n\t\t\t<td *ngFor=\"let cur of values | async\">\r\n\t\t\t\t<button  class=\"full-width\" mat-raised-button  (click)=\"selectVal(cur)\" [color]=\"localVal == cur.value? 'primary':'default'\">{{ cur.title || cur.value }}</button>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr><td colspan=\"2\"><small>{{ parent.qMap.subtitle | qmap_el: parent }}</small></td></tr>\r\n\t</table>\r\n</ng-container>\r\n\r\n<ng-container *ngIf=\"parent.lightWeight && (parent.qMap.style == 'buttons' || (!parent.qMap.style && parent.qMap.values && parent.qMap.values?.length <= 4))\" class=\"full-width\">\r\n\t<ng-container *ngFor=\"let cur of values | async\">\r\n\t\t\t<button  mat-raised-button  (click)=\"selectVal(cur)\" [color]=\"localVal == cur.value? 'primary':'default'\">{{ cur.title || cur.value }}</button>\r\n\t\t</ng-container>\r\n</ng-container>\r\n\r\n</ng-container>" }]
        }], ctorParameters: function () {
        return [{ type: QMAPService, decorators: [{
                        type: Inject,
                        args: [forwardRef(() => QMAPService)]
                    }] }];
    } });
class QuestionGroupComponent extends SubQuestionComponent {
    constructor(zone, TOU) {
        super();
        this.zone = zone;
        this.TOU = TOU;
        this.models = [];
        this.debog = window.location.search.indexOf('qmap-debug=true') != -1;
        this.debog1 = this.debog || window.location.search.indexOf('qmap-debug=1') != -1;
    }
    ngOnInit() {
        this.firstKey = this.parent.qMap.items.length ? this.parent.qMap.items[0].id : null;
        this.flatKey = this.parent.qMap.flatten && this.parent.qMap.items.length == 1 ? this.parent.qMap.items[0].id : null;
        this.parent.qMap.useSource = this.parent.qMap.useSource && this.parent.qMap.items.length == 1 ? this.parent.qMap.items[0].id : null;
        super.ngOnInit();
        if (this.parent.val) {
            this.refreshValues(this.parent.val);
        }
    }
    refreshValues(v) {
        if (v) {
            var i = 0;
            v.forEach(cur => {
                if (!cur) {
                    v[i] = {};
                }
                i++;
            });
            if (this.flatKey)
                this.models = v.map((v, i) => {
                    let val = {};
                    val[this.flatKey] = v;
                    return val;
                });
            else {
                this.models = v;
            }
        }
        else {
            this.models = [];
        }
    }
    ctxAndThenSome(extra) {
        let cp = Object.assign({}, this);
        if (!extra)
            return cp;
        Object.keys(extra).forEach(k => cp[k] = extra[k]);
        return cp;
    }
    boundEmitFN(a, b) {
        // ok so I have to dbind a non this object for each item in groupLayout tempalte
        // I bind this function but the 'this' is the new object, so a hack is make a meber called self thats the trueThis
        let aa = this;
        aa.trueThis.nestedEmit(a, b);
    }
    boundRMFN(index) {
        let aa = this;
        aa.trueThis.removeIndex(index);
    }
    removeIndex(index) {
        this.parent.val.splice(index, 1);
        // if its not a flattened array, its the same array so dont remove it 2wice
        if (this.flatKey)
            this.models.splice(index, 1);
        this.parent.updated(null, this);
        if (this.parent.validator)
            this.parent.validator.updateQuestionState(this.parent, this.isValid());
    }
    castDefaultValue(defaultVal) {
        if (typeof defaultVal == "number") {
            let a = [];
            for (; defaultVal > 0; defaultVal--) {
                a.push({});
            }
            return a;
        }
        else {
            console.warn("Unknown default val supplied");
            return null;
        }
    }
    nestedEmit(obj, index) {
        if (this.parent.qMap.style == 'autoadd' && (!obj || !(obj + '').length) || obj == this.TOU.posionPill) {
            this.parent.val.splice(index, 1);
            if (this.flatKey)
                this.models.splice(index, 1);
        }
        else if (this.flatKey && obj) {
            this.parent.val[index] = obj;
            this.models[index][this.flatKey] = this.parent.val[index];
        }
        else if (!obj && !Object.keys(this.models[index]).length) {
            this.parent.val.splice(index, 1);
            if (this.flatKey)
                this.models.splice(index, 1);
        }
        console.log(this.flatKey + " " + (this.models == this.parent.val));
        if (!this.flatKey && (this.models != this.parent.val)) {
            console.log('oy!');
            this.parent.val = this.models;
        }
        this.parent.updated(obj, this);
        this.parent.changeDetector.detectChanges();
    }
    addItem(byo) {
        this.autoAdd(byo || this.flatKey ? '' : {});
    }
    autoAdd(v) {
        if (!this.parent.val) {
            if (this.flatKey) {
                // when flatten is on, maintain invidiual arrays
                this.parent.val = [];
                this.models = [];
            }
            else {
                // when not flatten, reference same array
                var aa = [];
                this.parent.val = aa;
                this.models = aa;
            }
        }
        if (this.flatKey) {
            let val = {};
            val[this.flatKey] = v;
            this.models.push(val);
            this.parent.val.push(v);
        }
        else {
            // array is the same object when its not autoflat
            let val = {};
            this.models.push(val);
            //this.parent.val.push(val);
        }
        this.parent.updated(v, this);
        if (this.parent.validator)
            this.parent.validator.updateQuestionState(this.parent, this.isValid());
    }
    supportedTemplates() {
        return ['layout', 'child_layout', 'header'];
    }
    isValid() {
        return !this.parent.qMap.required || (this.parent.val && this.parent.val.length);
    }
    parentChange(a) {
        super.parentChange(a);
        console.log('array change');
        //this.refreshValues(this.parent.val)
    }
}
/** @nocollapse */ QuestionGroupComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QuestionGroupComponent, deps: [{ token: i0.NgZone }, { token: forwardRef(() => QMAPService) }], target: i0.ɵɵFactoryTarget.Component });
/** @nocollapse */ QuestionGroupComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.9", type: QuestionGroupComponent, selector: "[tou-group-question]", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"templates['inner_layout']\" [ngTemplateOutlet]=\"templates['inner_layout']\"\r\n        [ngTemplateOutletContext]=\"{localVal:localVal,templates:parent.templates,parent:parent,self:this}\">\r\n</ng-container>\r\n\r\n<ng-container *ngIf=\"!templates['inner_layout']\">\r\n<ng-container *ngIf=\"templates['header']\"\r\n        [ngTemplateOutlet]=\"templates['header']\"\r\n        [ngTemplateOutletContext]=\"this\">\r\n\r\n</ng-container>\r\n<div *ngIf=\"!templates['header'] && parent.qMap.title\">{{ parent.qMap.title | qmap_el:parent }} </div>\r\n\r\n<ng-container *ngIf=\"templates['child_layout']\">\r\n    <ng-container *ngFor=\"let curMod of models; let i = index\">\r\n        <ng-container \r\n            [ngTemplateOutlet]=\"templates['child_layout']\"\r\n            [ngTemplateOutletContext]=\"{index:i,model:models[i],templates:parent.templates,emitter:boundEmitFN,removeIndex:boundRMFN,trueThis:this,parent:parent}\">\r\n\r\n        </ng-container>\r\n    </ng-container>\r\n</ng-container>\r\n\r\n\r\n<div class=\"qmap_group\" *ngIf=\"!templates['child_layout']\">\r\n   <div class=\"group_item\" *ngFor=\"let curMod of models; let i = index\">\r\n       <button mat-icon-button (click)=\"removeIndex(i)\" class=\"rm_button\"><i class=\"fa fa-times text-default\"></i></button>  \r\n\r\n       <div qmap-question *ngFor=\"let curQMap of parent.qMap.items | qmap_filter:parent.scope\" [qMap]=\"curQMap\" [templates]=\"parent.templates\" [model]=\"curMod\" qmap-class=\"sub array\" (qmap-change)=\"nestedEmit($event,i)\" [parentQuestion]=\"parent\" [scope]=\"parent.scope\" [autoSave]=\"parent.autoSave\"  [appearance]=\"parent.appearance\"></div>\r\n    </div>\r\n</div>\r\n\r\n<ng-container *ngIf=\"parent.qMap.style == 'autoadd' && !templates['autoadd']\">\r\n\r\n\t<div qmap-question [qMap]=\"copyAndAdd(parent.qMap.items[0],{title:'Add new ' + parent.qMap.title})\" (qmap-change)=\"autoAdd($event)\" [parentQuestion]=\"parent\" [templates]=\"parent.templates\" [autoSave]=\"parent.autoSave\" [appearance]=\"parent.appearance\"></div>\r\n\r\n</ng-container>\r\n\r\n<div style=\"margin-bottom:5px;\" *ngIf=\"parent.qMap.style == 'addable' && !templates['addable']\">\r\n\r\n    <button mat-raised-button (click)=\"addItem()\" color=\"primary\">{{ parent.qMap.add_button || 'Add'}}</button>\r\n\r\n</div>\r\n<pre *ngIf=\"debog\">{{ parent.model | json }}</pre>\r\n<ng-container *ngIf=\"parent.qMap.style == 'addable' && templates['addable']\"\r\n    [ngTemplateOutlet]=\"templates['addable']\"\r\n    [ngTemplateOutletContext]=\"this\">\r\n\r\n</ng-container>\r\n\r\n<ng-container *ngIf=\"parent.qMap.style == 'autoadd' && templates['autoadd']\"\r\n    [ngTemplateOutlet]=\"templates['autoadd']\"\r\n    [ngTemplateOutletContext]=\"this\">\r\n\r\n</ng-container>\r\n</ng-container>\r\n", styles: [".qmap_group{margin-right:35px}.qmap_group .group_item{position:relative}.qmap_group .group_item .rm_button{position:absolute;right:-35px;top:5px}\n"], dependencies: [{ kind: "directive", type: i0.forwardRef(function () { return i3.NgForOf; }), selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgIf; }), selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgTemplateOutlet; }), selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i0.forwardRef(function () { return i15.MatButton; }), selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "component", type: i0.forwardRef(function () { return i15.MatIconButton; }), selector: "button[mat-icon-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "component", type: i0.forwardRef(function () { return QuestionComponent; }), selector: "[qmap-question]", inputs: ["readOnly", "qMap", "qmap-class", "lightWeight", "autoSave", "model", "vmodel", "parentQuestion", "templates", "bunched", "scope", "appearance", "validator"], outputs: ["qmap-change"], exportAs: ["touQuestion"] }, { kind: "pipe", type: i0.forwardRef(function () { return i3.JsonPipe; }), name: "json" }, { kind: "pipe", type: i0.forwardRef(function () { return QFilterPipe; }), name: "qmap_filter" }, { kind: "pipe", type: i0.forwardRef(function () { return QMAPExpressionLanguage; }), name: "qmap_el" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QuestionGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: '[tou-group-question]', template: "<ng-container *ngIf=\"templates['inner_layout']\" [ngTemplateOutlet]=\"templates['inner_layout']\"\r\n        [ngTemplateOutletContext]=\"{localVal:localVal,templates:parent.templates,parent:parent,self:this}\">\r\n</ng-container>\r\n\r\n<ng-container *ngIf=\"!templates['inner_layout']\">\r\n<ng-container *ngIf=\"templates['header']\"\r\n        [ngTemplateOutlet]=\"templates['header']\"\r\n        [ngTemplateOutletContext]=\"this\">\r\n\r\n</ng-container>\r\n<div *ngIf=\"!templates['header'] && parent.qMap.title\">{{ parent.qMap.title | qmap_el:parent }} </div>\r\n\r\n<ng-container *ngIf=\"templates['child_layout']\">\r\n    <ng-container *ngFor=\"let curMod of models; let i = index\">\r\n        <ng-container \r\n            [ngTemplateOutlet]=\"templates['child_layout']\"\r\n            [ngTemplateOutletContext]=\"{index:i,model:models[i],templates:parent.templates,emitter:boundEmitFN,removeIndex:boundRMFN,trueThis:this,parent:parent}\">\r\n\r\n        </ng-container>\r\n    </ng-container>\r\n</ng-container>\r\n\r\n\r\n<div class=\"qmap_group\" *ngIf=\"!templates['child_layout']\">\r\n   <div class=\"group_item\" *ngFor=\"let curMod of models; let i = index\">\r\n       <button mat-icon-button (click)=\"removeIndex(i)\" class=\"rm_button\"><i class=\"fa fa-times text-default\"></i></button>  \r\n\r\n       <div qmap-question *ngFor=\"let curQMap of parent.qMap.items | qmap_filter:parent.scope\" [qMap]=\"curQMap\" [templates]=\"parent.templates\" [model]=\"curMod\" qmap-class=\"sub array\" (qmap-change)=\"nestedEmit($event,i)\" [parentQuestion]=\"parent\" [scope]=\"parent.scope\" [autoSave]=\"parent.autoSave\"  [appearance]=\"parent.appearance\"></div>\r\n    </div>\r\n</div>\r\n\r\n<ng-container *ngIf=\"parent.qMap.style == 'autoadd' && !templates['autoadd']\">\r\n\r\n\t<div qmap-question [qMap]=\"copyAndAdd(parent.qMap.items[0],{title:'Add new ' + parent.qMap.title})\" (qmap-change)=\"autoAdd($event)\" [parentQuestion]=\"parent\" [templates]=\"parent.templates\" [autoSave]=\"parent.autoSave\" [appearance]=\"parent.appearance\"></div>\r\n\r\n</ng-container>\r\n\r\n<div style=\"margin-bottom:5px;\" *ngIf=\"parent.qMap.style == 'addable' && !templates['addable']\">\r\n\r\n    <button mat-raised-button (click)=\"addItem()\" color=\"primary\">{{ parent.qMap.add_button || 'Add'}}</button>\r\n\r\n</div>\r\n<pre *ngIf=\"debog\">{{ parent.model | json }}</pre>\r\n<ng-container *ngIf=\"parent.qMap.style == 'addable' && templates['addable']\"\r\n    [ngTemplateOutlet]=\"templates['addable']\"\r\n    [ngTemplateOutletContext]=\"this\">\r\n\r\n</ng-container>\r\n\r\n<ng-container *ngIf=\"parent.qMap.style == 'autoadd' && templates['autoadd']\"\r\n    [ngTemplateOutlet]=\"templates['autoadd']\"\r\n    [ngTemplateOutletContext]=\"this\">\r\n\r\n</ng-container>\r\n</ng-container>\r\n", styles: [".qmap_group{margin-right:35px}.qmap_group .group_item{position:relative}.qmap_group .group_item .rm_button{position:absolute;right:-35px;top:5px}\n"] }]
        }], ctorParameters: function () {
        return [{ type: i0.NgZone }, { type: QMAPService, decorators: [{
                        type: Inject,
                        args: [forwardRef(() => QMAPService)]
                    }] }];
    } });
class QuestionLocationComponent extends SubQuestionComponent {
    constructor(el, da) {
        super();
        this.el = el;
        this.da = da;
        this.objId = "map_" + Math.random();
        this.objId = this.objId.replace('0.', '');
    }
    ngOnInit() {
        super.ngOnInit();
    }
    ngAfterViewInit() {
        /*
        setTimeout(() => {

            this.map = L.map(this.objId,{})
            if(this.localVal)
                this.map.setView([this.localVal.lat,this.localVal.lng], 13);
            else
                this.map.setView([-25.16517336866393,134.0771484375], 5);
            L.tileLayer('http://a.tiles.mapbox.com/v3/correllink.ge839f2g/{z}/{x}/{y}.png').addTo(this.map);

            this.map.on('click', (ev) => {
                this.setPeg(ev.latlng)
                this.applyValue({lat:ev.latlng.lat,lng:ev.latlng.lng})
            });
            if(this.localVal){
                console.log(this.localVal)
                this.setPeg(this.localVal)
            }
        }
        ,1000)
        */
    }
    setPeg(ll) {
        /*
        if(!this.peg){
            let icon = L.icon({
                iconUrl: '/assets/images/marker-icon.png',
                iconSize: [38, 55],
                iconAnchor: [22, 54]
            })
            this.peg = L.marker(ll,{icon:icon})
            this.peg.addTo(this.map)

        }
        this.peg.setLatLng(ll)
        */
    }
    supportedTemplates() {
        return [];
    }
}
/** @nocollapse */ QuestionLocationComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QuestionLocationComponent, deps: [{ token: i0.ElementRef }, { token: i9.DateAdapter }], target: i0.ɵɵFactoryTarget.Component });
/** @nocollapse */ QuestionLocationComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.9", type: QuestionLocationComponent, selector: "tou-location-question", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"templates['inner_layout']\" [ngTemplateOutlet]=\"templates['inner_layout']\"\r\n        [ngTemplateOutletContext]=\"{dateVal:dateVal,localVal:localVal,templates:parent.templates,parent:parent,self:this}\">\r\n</ng-container>\r\n\r\n<div *ngIf=\"!templates['inner_layout']\" >\r\n\t{{ parent.qMap.title | qmap_el:parent}}\r\n\t<div [id]=\"objId\" style=\"width:100%;height:350px;\"></div>\r\n\t<div class=\"text-right\">\r\n\t\t{{ parent.qMap.subtitle | qmap_el:parent}}\r\n\t</div>\r\n</div>", dependencies: [{ kind: "directive", type: i0.forwardRef(function () { return i3.NgIf; }), selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgTemplateOutlet; }), selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "pipe", type: i0.forwardRef(function () { return QMAPExpressionLanguage; }), name: "qmap_el" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QuestionLocationComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tou-location-question', template: "<ng-container *ngIf=\"templates['inner_layout']\" [ngTemplateOutlet]=\"templates['inner_layout']\"\r\n        [ngTemplateOutletContext]=\"{dateVal:dateVal,localVal:localVal,templates:parent.templates,parent:parent,self:this}\">\r\n</ng-container>\r\n\r\n<div *ngIf=\"!templates['inner_layout']\" >\r\n\t{{ parent.qMap.title | qmap_el:parent}}\r\n\t<div [id]=\"objId\" style=\"width:100%;height:350px;\"></div>\r\n\t<div class=\"text-right\">\r\n\t\t{{ parent.qMap.subtitle | qmap_el:parent}}\r\n\t</div>\r\n</div>" }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i9.DateAdapter }]; } });
const M = Moment;
class QuestionDateComponent extends SubQuestionComponent {
    constructor(el, da) {
        super();
        this.da = da;
        this.showDate = true;
        this.hours = [];
        this.mins = [];
        var x = 0;
        for (x = 0; x < 24; x++) {
            this.hours.push(x);
        }
        for (x = 0; x < 60; x += 5) {
            this.mins.push(x);
        }
    }
    ngOnInit() {
        super.ngOnInit();
        var d = this.localVal;
        if (d) {
            if (typeof d == 'number')
                d = new Date(d);
            this.min = Math.round(d.getMinutes() / 5) * 5;
            this.hour = d.getHours();
            this.dateVal = M(d);
        }
    }
    castDefaultValue(defaultVal) {
        if (typeof defaultVal == "string") {
            if (defaultVal.indexOf("{{") != -1) {
                return this.castDefaultValue(defaultVal.qmap_template(this.parent));
            }
            else if (defaultVal.startsWith('+')) {
                return new Date().getTime() + parseInt(defaultVal.substring(1));
            }
            else if (defaultVal.startsWith('-')) {
                return new Date().getTime() - parseInt(defaultVal.substring(1));
            }
            else {
                return parseInt(defaultVal.substring(1));
            }
        }
        else if (typeof defaultVal == 'number')
            return defaultVal;
        else {
            console.warn("Unknown default val supplied");
            return null;
        }
    }
    applyValue(a) {
        if (!a)
            a = this.dateVal || new Date();
        else if (typeof a == 'number')
            a = new Date(a);
        if (a.toDate)
            a = a.toDate();
        if (this.hour)
            a.setHours(this.hour);
        if (this.min)
            a.setMinutes(this.min);
        super.applyValue(a ? a.getTime() : null);
    }
    supportedTemplates() {
        return [];
    }
}
/** @nocollapse */ QuestionDateComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QuestionDateComponent, deps: [{ token: i0.ElementRef }, { token: i9.DateAdapter }], target: i0.ɵɵFactoryTarget.Component });
/** @nocollapse */ QuestionDateComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.9", type: QuestionDateComponent, selector: "tou-date-question", inputs: { showTime: "showTime", showDate: "showDate" }, usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"templates['inner_layout']\" [ngTemplateOutlet]=\"templates['inner_layout']\"\r\n        [ngTemplateOutletContext]=\"{dateVal:dateVal,localVal:localVal,templates:parent.templates,parent:parent,self:this}\">\r\n</ng-container>\r\n\r\n<ng-container *ngIf=\"!templates['inner_layout']\" >\r\n\t<mat-form-field *ngIf=\"showDate\" [appearance]=\"parent.appearance\" class=\"full-width\">\r\n\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t\t<input \r\n\t\t\tmatInput \r\n\t\t\t[name]=\"parent.qMap.id + '_dd'\" \r\n\t\t\t[matDatepicker]=\"picker\" \r\n\t\t\t[(ngModel)]=\"dateVal\" \r\n\t\t\t[placeholder]=\"parent.qMap.title | qmap_el:parent\" \r\n\t\t\t(ngModelChange)=\"applyValue(dateVal)\"\r\n\t\t\t[required]=\"parent.qMap.required\">\r\n\t\t<mat-datepicker [disabled]=\"parent.qMap.disabled\" [startAt]=\"dateVal\" [touchUi]=\"parent.qMap.style == 'touch'\" #picker></mat-datepicker>\r\n\t\t<!--\r\n\t\t<i *ngIf=\"parent.qMap.required && !localVal\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\t\t-->\r\n\t\t<mat-datepicker-toggle matSuffix [for]=\"picker\"></mat-datepicker-toggle>\r\n\t\t<mat-error *ngIf=\"parent.qMap.required\">Field Required</mat-error >\r\n\t</mat-form-field>\r\n\t\r\n\t<mat-form-field *ngIf=\"showTime\" style=\"width:90px;\" [appearance]=\"parent.appearance\">\r\n\t\t<mat-label>Hour</mat-label>\r\n\t\t<mat-select [disabled]=\"parent.qMap.disabled\" style=\"width:75px;\" placeholder=\"Hour\" [name]=\"parent.qMap.id + '_hh'\" [(ngModel)]=\"hour\" (ngModelChange)=\"applyValue()\">\r\n\t\t\t\t<mat-option *ngFor=\"let item of hours\" [value]=\"item\">{{ item }}</mat-option>\r\n\t\t</mat-select>\r\n\r\n\t</mat-form-field>\r\n\t<mat-form-field *ngIf=\"showTime\" style=\"width:90px;\" [appearance]=\"parent.appearance\">\r\n\t\t<mat-label>Minute</mat-label>\r\n\t\t<mat-select [disabled]=\"parent.qMap.disabled\" style=\"width:75px;\" placeholder=\"Minute\" [name]=\"parent.qMap.id + '_mm'\" [(ngModel)]=\"min\"  (ngModelChange)=\"applyValue()\">\r\n\t\t\t<mat-option *ngFor=\"let item of mins\" [value]=\"item\">{{ item < 10 ? 0 : '' }}{{ item }}</mat-option>\r\n\t\t</mat-select>\r\n\r\n\t</mat-form-field>\r\n\r\n</ng-container>", dependencies: [{ kind: "directive", type: i0.forwardRef(function () { return i3.NgForOf; }), selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgIf; }), selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i0.forwardRef(function () { return i3.NgTemplateOutlet; }), selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i0.forwardRef(function () { return i7.DefaultValueAccessor; }), selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i0.forwardRef(function () { return i7.NgControlStatus; }), selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i0.forwardRef(function () { return i7.RequiredValidator; }), selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i0.forwardRef(function () { return i7.NgModel; }), selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i0.forwardRef(function () { return i9.MatOption; }), selector: "mat-option", exportAs: ["matOption"] }, { kind: "component", type: i0.forwardRef(function () { return i17.MatDatepicker; }), selector: "mat-datepicker", exportAs: ["matDatepicker"] }, { kind: "directive", type: i0.forwardRef(function () { return i17.MatDatepickerInput; }), selector: "input[matDatepicker]", inputs: ["matDatepicker", "min", "max", "matDatepickerFilter"], exportAs: ["matDatepickerInput"] }, { kind: "component", type: i0.forwardRef(function () { return i17.MatDatepickerToggle; }), selector: "mat-datepicker-toggle", inputs: ["for", "tabIndex", "aria-label", "disabled", "disableRipple"], exportAs: ["matDatepickerToggle"] }, { kind: "component", type: i0.forwardRef(function () { return i10.MatFormField; }), selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i0.forwardRef(function () { return i10.MatLabel; }), selector: "mat-label" }, { kind: "directive", type: i0.forwardRef(function () { return i10.MatError; }), selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i0.forwardRef(function () { return i10.MatSuffix; }), selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "component", type: i0.forwardRef(function () { return i11.MatSelect; }), selector: "mat-select", inputs: ["disabled", "disableRipple", "tabIndex", "hideSingleSelectionIndicator"], exportAs: ["matSelect"] }, { kind: "directive", type: i0.forwardRef(function () { return i13.MatInput; }), selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "pipe", type: i0.forwardRef(function () { return QMAPExpressionLanguage; }), name: "qmap_el" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QuestionDateComponent, decorators: [{
            type: Component,
            args: [{ selector: 'tou-date-question', template: "<ng-container *ngIf=\"templates['inner_layout']\" [ngTemplateOutlet]=\"templates['inner_layout']\"\r\n        [ngTemplateOutletContext]=\"{dateVal:dateVal,localVal:localVal,templates:parent.templates,parent:parent,self:this}\">\r\n</ng-container>\r\n\r\n<ng-container *ngIf=\"!templates['inner_layout']\" >\r\n\t<mat-form-field *ngIf=\"showDate\" [appearance]=\"parent.appearance\" class=\"full-width\">\r\n\t\t<mat-label>{{ ( parent.qMap.title || parent.qMap.id ) | qmap_el: parent }}</mat-label>\r\n\t\t<input \r\n\t\t\tmatInput \r\n\t\t\t[name]=\"parent.qMap.id + '_dd'\" \r\n\t\t\t[matDatepicker]=\"picker\" \r\n\t\t\t[(ngModel)]=\"dateVal\" \r\n\t\t\t[placeholder]=\"parent.qMap.title | qmap_el:parent\" \r\n\t\t\t(ngModelChange)=\"applyValue(dateVal)\"\r\n\t\t\t[required]=\"parent.qMap.required\">\r\n\t\t<mat-datepicker [disabled]=\"parent.qMap.disabled\" [startAt]=\"dateVal\" [touchUi]=\"parent.qMap.style == 'touch'\" #picker></mat-datepicker>\r\n\t\t<!--\r\n\t\t<i *ngIf=\"parent.qMap.required && !localVal\" class=\"fa  {{ invalidIcon }} {{ invalidColour }}\" [matTooltip]=\"invalidTooltip\" matSuffix></i>\r\n\t\t-->\r\n\t\t<mat-datepicker-toggle matSuffix [for]=\"picker\"></mat-datepicker-toggle>\r\n\t\t<mat-error *ngIf=\"parent.qMap.required\">Field Required</mat-error >\r\n\t</mat-form-field>\r\n\t\r\n\t<mat-form-field *ngIf=\"showTime\" style=\"width:90px;\" [appearance]=\"parent.appearance\">\r\n\t\t<mat-label>Hour</mat-label>\r\n\t\t<mat-select [disabled]=\"parent.qMap.disabled\" style=\"width:75px;\" placeholder=\"Hour\" [name]=\"parent.qMap.id + '_hh'\" [(ngModel)]=\"hour\" (ngModelChange)=\"applyValue()\">\r\n\t\t\t\t<mat-option *ngFor=\"let item of hours\" [value]=\"item\">{{ item }}</mat-option>\r\n\t\t</mat-select>\r\n\r\n\t</mat-form-field>\r\n\t<mat-form-field *ngIf=\"showTime\" style=\"width:90px;\" [appearance]=\"parent.appearance\">\r\n\t\t<mat-label>Minute</mat-label>\r\n\t\t<mat-select [disabled]=\"parent.qMap.disabled\" style=\"width:75px;\" placeholder=\"Minute\" [name]=\"parent.qMap.id + '_mm'\" [(ngModel)]=\"min\"  (ngModelChange)=\"applyValue()\">\r\n\t\t\t<mat-option *ngFor=\"let item of mins\" [value]=\"item\">{{ item < 10 ? 0 : '' }}{{ item }}</mat-option>\r\n\t\t</mat-select>\r\n\r\n\t</mat-form-field>\r\n\r\n</ng-container>" }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i9.DateAdapter }]; }, propDecorators: { showTime: [{
                type: Input
            }], showDate: [{
                type: Input
            }] } });
class QMAPExpressionLanguage {
    transform(template, question) {
        if (!template || template.indexOf('{{') == -1)
            return template;
        else if (question instanceof QuestionComponent)
            return template.qmap_template(question.superModel());
        else
            return template.qmap_template(question);
    }
}
/** @nocollapse */ QMAPExpressionLanguage.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QMAPExpressionLanguage, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
/** @nocollapse */ QMAPExpressionLanguage.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.2.9", ngImport: i0, type: QMAPExpressionLanguage, name: "qmap_el" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QMAPExpressionLanguage, decorators: [{
            type: Pipe,
            args: [{ name: 'qmap_el' }]
        }] });

class EditorComponent {
    constructor(service) {
        this.service = service;
        this.loading = true;
        this.change = new EventEmitter();
        this.close = new EventEmitter();
        this.errorEmitter = new EventEmitter();
    }
    ngOnInit() {
        this.canWrite = this.service.canWrite(this.model);
        this.canDel = this.service.canDelete(this.model);
        this.loading = false;
    }
    onSave() {
        this.model.saveObservable().subscribe(s => this.close.emit({ saved: true, deleted: false, model: this.model }), (e) => {
            this.error = e;
            this.errorEmitter.emit(e);
        });
    }
    nuke() {
        this.model.destroyObservable().subscribe(s => this.close.emit({ saved: false, deleted: true, model: this.model }), (e) => {
            this.error = e;
            this.errorEmitter.emit(e);
        });
    }
    onCNX() {
        this.close.emit({ saved: false, deleted: false, model: this.model });
    }
}
/** @nocollapse */ EditorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: EditorComponent, deps: [{ token: QMAPService }], target: i0.ɵɵFactoryTarget.Component });
/** @nocollapse */ EditorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.9", type: EditorComponent, selector: "qmap-editor", inputs: { qMap: "qMap", model: "model" }, outputs: { change: "qmap-change", close: "close", errorEmitter: "error" }, ngImport: i0, template: "<section class=\"qmap_editor abs\" *ngIf=\"qMap\" qmap-validator #validator=\"qmap-validator\">\r\n\t<div class=\"padding title_pane\">\r\n\r\n\t\t<button mat-icon-button class=\"cnx_button\" (click)=\"onCNX()\"><i class=\"fa fa-times\"></i></button> \r\n\t\t<div class=\"heading_text\" qmap-question [model]=\"model\" [qMap]=\"{id:'name',type:'shorttext',title:'Name',required:true}\"></div>\r\n\t\t<div *ngIf=\"error\" class=\"alert alert-danger\">\r\n\t\t\t{{ error.message }}\r\n\t\t</div>\r\n\r\n\t</div>\r\n\t<mat-progress-bar *ngIf=\"model.loading\" mode=\"indeterminate\"></mat-progress-bar>\r\n\t<div *ngIf=\"model && !loading\" class=\"question_pane oflow\" [ngClass]=\"{'padding':qMap[0]?.type != 'bunch','white-wash':true}\">\r\n\t\t<div *ngFor=\"let curQ of qMap\" qmap-question [qMap]=\"curQ\" [model]=\"model\" [vmodel]=\"model\" class=\"block\" [readOnly]=\"!canWrite\" (qmap-change)=\"change.emit($event)\">\r\n\t\t</div>\r\n\t</div>\r\n\r\n\t<div class=\"text-right padding footer_pane\">\r\n\t\t<button [disabled]=\"!canWrite || !validator.valid\" mat-raised-button color=\"primary\" (click)=\"onSave()\"><i class=\"fa fa-floppy-o\" ></i> Save</button>\r\n\t\t\r\n\t\t<button mat-raised-button color=\"warn\" (click)=\"nuke()\" *ngIf=\"canDel\"><i class=\"fa fa-trash-o\" ></i> Delete</button> \r\n\r\n\t</div>\r\n</section>\r\n", dependencies: [{ kind: "directive", type: i3.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i3.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i3.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i15.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "component", type: i15.MatIconButton, selector: "button[mat-icon-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "component", type: i4$1.MatProgressBar, selector: "mat-progress-bar", inputs: ["color", "value", "bufferValue", "mode"], outputs: ["animationEnd"], exportAs: ["matProgressBar"] }, { kind: "component", type: QuestionComponent, selector: "[qmap-question]", inputs: ["readOnly", "qMap", "qmap-class", "lightWeight", "autoSave", "model", "vmodel", "parentQuestion", "templates", "bunched", "scope", "appearance", "validator"], outputs: ["qmap-change"], exportAs: ["touQuestion"] }, { kind: "directive", type: QuestionValidatorDirective, selector: "qmap-validator,[qmap-validator]", exportAs: ["qmap-validator"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: EditorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'qmap-editor', template: "<section class=\"qmap_editor abs\" *ngIf=\"qMap\" qmap-validator #validator=\"qmap-validator\">\r\n\t<div class=\"padding title_pane\">\r\n\r\n\t\t<button mat-icon-button class=\"cnx_button\" (click)=\"onCNX()\"><i class=\"fa fa-times\"></i></button> \r\n\t\t<div class=\"heading_text\" qmap-question [model]=\"model\" [qMap]=\"{id:'name',type:'shorttext',title:'Name',required:true}\"></div>\r\n\t\t<div *ngIf=\"error\" class=\"alert alert-danger\">\r\n\t\t\t{{ error.message }}\r\n\t\t</div>\r\n\r\n\t</div>\r\n\t<mat-progress-bar *ngIf=\"model.loading\" mode=\"indeterminate\"></mat-progress-bar>\r\n\t<div *ngIf=\"model && !loading\" class=\"question_pane oflow\" [ngClass]=\"{'padding':qMap[0]?.type != 'bunch','white-wash':true}\">\r\n\t\t<div *ngFor=\"let curQ of qMap\" qmap-question [qMap]=\"curQ\" [model]=\"model\" [vmodel]=\"model\" class=\"block\" [readOnly]=\"!canWrite\" (qmap-change)=\"change.emit($event)\">\r\n\t\t</div>\r\n\t</div>\r\n\r\n\t<div class=\"text-right padding footer_pane\">\r\n\t\t<button [disabled]=\"!canWrite || !validator.valid\" mat-raised-button color=\"primary\" (click)=\"onSave()\"><i class=\"fa fa-floppy-o\" ></i> Save</button>\r\n\t\t\r\n\t\t<button mat-raised-button color=\"warn\" (click)=\"nuke()\" *ngIf=\"canDel\"><i class=\"fa fa-trash-o\" ></i> Delete</button> \r\n\r\n\t</div>\r\n</section>\r\n" }]
        }], ctorParameters: function () { return [{ type: QMAPService }]; }, propDecorators: { qMap: [{
                type: Input
            }], model: [{
                type: Input
            }], change: [{
                type: Output,
                args: ['qmap-change']
            }], close: [{
                type: Output,
                args: ['close']
            }], errorEmitter: [{
                type: Output,
                args: ['error']
            }] } });

class QMAPModule {
}
/** @nocollapse */ QMAPModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QMAPModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
/** @nocollapse */ QMAPModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.2.9", ngImport: i0, type: QMAPModule, declarations: [QFilterPipe, QPercentPipe, QRoundPipe, QMomentPipe,
        QuestionLocationComponent, QuestionChoiceComponent,
        QMAPTemplate, QuestionComponent, QuestionSimpleComponent, QuestionObjectComponent,
        QuestionDateComponent, QuestionGroupComponent,
        QMAPExpressionLanguage, QuestionValidatorDirective, EditorComponent], imports: [CommonModule, FormsModule, ReactiveFormsModule,
        MatAutocompleteModule,
        MatNativeDateModule,
        MatDatepickerModule,
        MatSnackBarModule,
        MatSelectModule,
        MatProgressSpinnerModule,
        MatTabsModule,
        MatFormFieldModule,
        MatButtonModule,
        MatCardModule,
        MatCheckboxModule,
        MatProgressBarModule,
        MatInputModule,
        MatTooltipModule
        //,FroalaEditorModule.forRoot(), FroalaViewModule.forRoot()
    ], exports: [EditorComponent,
        QFilterPipe, QPercentPipe, QRoundPipe, QMomentPipe,
        QuestionComponent, QuestionChoiceComponent, QMAPTemplate, QuestionSimpleComponent,
        QuestionObjectComponent, QuestionDateComponent, QuestionGroupComponent, QMAPExpressionLanguage, QuestionValidatorDirective, QuestionLocationComponent] });
/** @nocollapse */ QMAPModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QMAPModule, providers: [
        // The locale would typically be provided on the root module of your application. We do it at
        // the component level here, due to limitations of our example generation script.
        { provide: MAT_DATE_LOCALE, useValue: 'en-GB' },
        // `MomentDateAdapter` and `MAT_MOMENT_DATE_FORMATS` can be automatically provided by importing
        // `MatMomentDateModule` in your applications root module. We provide it at the component level
        // here, due to limitations of our example generation script.
        { provide: DateAdapter, useClass: MomentDateAdapter, deps: [MAT_DATE_LOCALE] },
        { provide: MAT_DATE_FORMATS, useValue: MAT_MOMENT_DATE_FORMATS },
    ], imports: [CommonModule, FormsModule, ReactiveFormsModule,
        MatAutocompleteModule,
        MatNativeDateModule,
        MatDatepickerModule,
        MatSnackBarModule,
        MatSelectModule,
        MatProgressSpinnerModule,
        MatTabsModule,
        MatFormFieldModule,
        MatButtonModule,
        MatCardModule,
        MatCheckboxModule,
        MatProgressBarModule,
        MatInputModule,
        MatTooltipModule
        //,FroalaEditorModule.forRoot(), FroalaViewModule.forRoot()
    ] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.9", ngImport: i0, type: QMAPModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule, FormsModule, ReactiveFormsModule,
                        MatAutocompleteModule,
                        MatNativeDateModule,
                        MatDatepickerModule,
                        MatSnackBarModule,
                        MatSelectModule,
                        MatProgressSpinnerModule,
                        MatTabsModule,
                        MatFormFieldModule,
                        MatButtonModule,
                        MatCardModule,
                        MatCheckboxModule,
                        MatProgressBarModule,
                        MatInputModule,
                        MatTooltipModule
                        //,FroalaEditorModule.forRoot(), FroalaViewModule.forRoot()
                    ],
                    providers: [
                        // The locale would typically be provided on the root module of your application. We do it at
                        // the component level here, due to limitations of our example generation script.
                        { provide: MAT_DATE_LOCALE, useValue: 'en-GB' },
                        // `MomentDateAdapter` and `MAT_MOMENT_DATE_FORMATS` can be automatically provided by importing
                        // `MatMomentDateModule` in your applications root module. We provide it at the component level
                        // here, due to limitations of our example generation script.
                        { provide: DateAdapter, useClass: MomentDateAdapter, deps: [MAT_DATE_LOCALE] },
                        { provide: MAT_DATE_FORMATS, useValue: MAT_MOMENT_DATE_FORMATS },
                    ],
                    declarations: [
                        QFilterPipe, QPercentPipe, QRoundPipe, QMomentPipe,
                        QuestionLocationComponent, QuestionChoiceComponent,
                        QMAPTemplate, QuestionComponent, QuestionSimpleComponent, QuestionObjectComponent,
                        QuestionDateComponent, QuestionGroupComponent,
                        QMAPExpressionLanguage, QuestionValidatorDirective, EditorComponent
                    ],
                    exports: [
                        EditorComponent,
                        QFilterPipe, QPercentPipe, QRoundPipe, QMomentPipe,
                        QuestionComponent, QuestionChoiceComponent, QMAPTemplate, QuestionSimpleComponent,
                        QuestionObjectComponent, QuestionDateComponent, QuestionGroupComponent, QMAPExpressionLanguage, QuestionValidatorDirective, QuestionLocationComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of qmap
 */

/**
 * Generated bundle index. Do not edit.
 */

export { EditorComponent, QFilterPipe, QMAPExpressionLanguage, QMAPModule, QMAPService, QMAPTemplate, QMapSchema, QMomentPipe, QPercentPipe, QRoundPipe, QuestionChoiceComponent, QuestionComponent, QuestionDateComponent, QuestionGroupComponent, QuestionLocationComponent, QuestionObjectComponent, QuestionSimpleComponent, QuestionValidatorDirective, StubModel, SubQuestionComponent };
//# sourceMappingURL=ng-qmap.mjs.map
