import { Observable } from "rxjs";
export interface ServerModel {
    name: string;
    id: number;
    [key: string]: any;
    fetchObservable(): Observable<ServerModel>;
    saveObservable(): Observable<ServerModel>;
    destroyObservable(): Observable<ServerModel>;
    toJSON(): any;
    set(a: any): ServerModel;
    file(s: string): string;
    rootPath(): string;
}
export declare class StubModel implements ServerModel {
    name: string;
    id: number;
    fetchObservable(): Observable<ServerModel>;
    saveObservable(): Observable<ServerModel>;
    destroyObservable(): Observable<ServerModel>;
    toJSON(): any;
    set(a: any): ServerModel;
    file(s: any): string;
    rootPath(): string;
}
export interface QMAP {
    id: string;
    type: string;
    style?: string;
    title?: string;
    subtitle?: string;
    [key: string]: any;
}
export declare class QMapSchema {
    qMapQuestions: any[];
    questions: ({
        type: string;
        title: string;
        id: string;
        onPos?: undefined;
        onNeg?: undefined;
        style?: undefined;
        items?: undefined;
    } | {
        id: string;
        type: string;
        title: string;
        onPos: {
            type: string;
            title: string;
            id: string;
            subititle: string;
        }[];
        onNeg: any[];
        style?: undefined;
        items?: undefined;
    } | {
        type: string;
        title: string;
        id: string;
        style: string;
        items: any[];
        onPos?: undefined;
        onNeg?: undefined;
    })[];
    constructor();
}
