/************************************************************************************************************************
 * All questions components are placed in this big simple file to avoid circular dependency as is not support in IVY compilation
 ************************************************************************************************************************/
import { EventEmitter, ElementRef, ChangeDetectorRef, TemplateRef, QueryList, NgZone } from '@angular/core';
import { QuestionValidatorDirective } from './questions-validator.directive';
import { QMAP, ServerModel } from './qmap.types';
import { QMAPService } from './qmap.service';
import { MatSnackBar } from '@angular/material/snack-bar';
import { FormControl } from '@angular/forms';
import { Observable } from 'rxjs';
import { DateAdapter } from '@angular/material/core';
import * as i0 from "@angular/core";
export declare class QMAPTemplate {
    parent: QuestionComponent;
    qMap: string;
    qType: string;
    qMode: string;
    template: TemplateRef<any>;
    static ɵfac: i0.ɵɵFactoryDeclaration<QMAPTemplate, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<QMAPTemplate, "qmap-template", never, { "qMap": "qMap_id"; "qType": "qMap_type"; "qMode": "mode"; }, {}, ["template"], never, false, never>;
}
export declare class QuestionComponent {
    private tou;
    protected snackBar: MatSnackBar;
    protected el: ElementRef;
    changeDetector: ChangeDetectorRef;
    validator: QuestionValidatorDirective;
    readOnly: boolean;
    qMap: QMAP;
    cssClass: any;
    lightWeight: any;
    autoSave: boolean;
    model: ServerModel;
    vmodel: ServerModel;
    parentQuestion: QuestionComponent;
    outEvent: EventEmitter<any>;
    templates: QMAPTemplate[];
    bunched: boolean;
    scope: any;
    appearance: string;
    onSelectQMap: QMAP[];
    set _validator(v: QuestionValidatorDirective);
    readOnlyTemplate: TemplateRef<any>;
    layoutTemplate: TemplateRef<any>;
    nestTemplate: TemplateRef<any>;
    blankModel: boolean;
    ready: boolean;
    subs: QMAP[];
    widget: SubQuestionComponent;
    set _template(a: QueryList<QMAPTemplate>);
    get val(): any;
    set val(a: any);
    constructor(tou: QMAPService, snackBar: MatSnackBar, el: ElementRef, changeDetector: ChangeDetectorRef, validator: QuestionValidatorDirective);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    stopLoop: number;
    ngOnChanges(changes: any): void;
    needsBcast(obj: any): boolean;
    ngOnDestroy(): void;
    initTemplates(): void;
    private hasRegged;
    _validatorReg(): void;
    animate(): "root" | "child";
    updated(value: any, subQ?: SubQuestionComponent, child?: QuestionComponent): void;
    realModel(): ServerModel;
    superModel(): any;
    /**
     * Get the iamge / file Uri. used for readOnly mode
     */
    getFileUri(): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<QuestionComponent, [null, null, null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuestionComponent, "[qmap-question]", ["touQuestion"], { "readOnly": "readOnly"; "qMap": "qMap"; "cssClass": "qmap-class"; "lightWeight": "lightWeight"; "autoSave": "autoSave"; "model": "model"; "vmodel": "vmodel"; "parentQuestion": "parentQuestion"; "templates": "templates"; "bunched": "bunched"; "scope": "scope"; "appearance": "appearance"; "_validator": "validator"; }, { "outEvent": "qmap-change"; }, ["_template"], never, false, never>;
}
export declare abstract class SubQuestionComponent {
    parent: QuestionComponent;
    bypass: boolean;
    outEvent: EventEmitter<any>;
    localVal: any;
    templates: {};
    invalidIcon: string;
    invalidColour: string;
    invalidTooltip: string;
    abstract supportedTemplates(): string[];
    ngOnInit(): void;
    initValue(): void;
    castDefaultValue(dv: any): any;
    parentChange(change: any): void;
    subValues(val?: any): void;
    applyValue(obj: any): void;
    copyAndAdd(obj: any, add: any): {};
    isValid(): any;
    addSubQuestion(a: any): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SubQuestionComponent, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<SubQuestionComponent, never, never, { "parent": "parent"; "bypass": "bypass"; }, { "outEvent": "qmap-change"; }, never, never, false, never>;
}
export declare class QuestionObjectComponent extends SubQuestionComponent {
    private service;
    modelname: string;
    control: FormControl;
    results: Observable<any>;
    addQMap: QMAP[];
    isAdd: boolean;
    clicked: boolean;
    typing: boolean;
    pulldownItems: any[];
    cssClass: any;
    constructor(service: QMAPService);
    ngOnInit(): void;
    compareW(a: any, b: any): boolean;
    selectLightVal(e: any): void;
    selectVal(e: any): void;
    initValue(): void;
    lock: number;
    parentChange(a: any): void;
    searchObservable(name: any): Observable<any[]>;
    checkVal(e: any): void;
    applyValue(v: any): void;
    displayFn(v: any): any;
    supportedTemplates(): string[];
    static ɵfac: i0.ɵɵFactoryDeclaration<QuestionObjectComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuestionObjectComponent, "[tou-object-question]", never, {}, {}, never, never, false, never>;
}
export declare class QuestionSimpleComponent extends SubQuestionComponent {
    htmlCfg: any;
    jsonError: boolean;
    localBool: any;
    get htmlVal(): any;
    set htmlVal(s: any);
    constructor();
    ngOnInit(): void;
    initValue(): void;
    subValues(a: any): void;
    parentChange(change: any): void;
    supportedTemplates(): any[];
    jsParse(): boolean;
    applyValue(v: any): void;
    isValid(): any;
    static ɵfac: i0.ɵɵFactoryDeclaration<QuestionSimpleComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuestionSimpleComponent, "tou-simple-question", never, {}, {}, never, never, false, never>;
}
export declare class QuestionChoiceComponent extends QuestionSimpleComponent {
    private service;
    myControl: FormControl;
    values: Observable<any[]>;
    localObj: {
        value: any;
        title?: any;
        onSelect?: QMAP[];
    };
    constructor(service: QMAPService);
    ngOnInit(): void;
    initValue(): void;
    filterValues(search?: string): Observable<any[]>;
    parentChange(change: any): void;
    selectValViaPulldown(e: any): void;
    selectVal(e: any): void;
    subValues(a: any): void;
    displayWith(e: any): any;
    static ɵfac: i0.ɵɵFactoryDeclaration<QuestionChoiceComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuestionChoiceComponent, "tou-choice-question,[tou-choice-question]", never, {}, {}, never, never, false, never>;
}
export declare class QuestionGroupComponent extends SubQuestionComponent {
    private zone;
    private TOU;
    models: any[];
    flatKey: string;
    firstKey: string;
    debog: boolean;
    debog1: boolean;
    constructor(zone: NgZone, TOU: QMAPService);
    ngOnInit(): void;
    refreshValues(v: any[]): void;
    ctxAndThenSome(extra: any): {} & this;
    boundEmitFN(a: any, b: any): void;
    boundRMFN(index: any): void;
    removeIndex(index: any): void;
    castDefaultValue(defaultVal: any): any[];
    nestedEmit(obj: any, index: any): void;
    addItem(byo?: any): void;
    autoAdd(v: any): void;
    supportedTemplates(): string[];
    isValid(): any;
    parentChange(a: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<QuestionGroupComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuestionGroupComponent, "[tou-group-question]", never, {}, {}, never, never, false, never>;
}
export declare class QuestionLocationComponent extends SubQuestionComponent {
    private el;
    private da;
    map: any;
    objId: string;
    dateVal: any;
    peg: any;
    constructor(el: ElementRef, da: DateAdapter<any>);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    setPeg(ll: any): void;
    supportedTemplates(): any[];
    static ɵfac: i0.ɵɵFactoryDeclaration<QuestionLocationComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuestionLocationComponent, "tou-location-question", never, {}, {}, never, never, false, never>;
}
export declare class QuestionDateComponent extends SubQuestionComponent {
    private da;
    showTime: boolean;
    showDate: boolean;
    dateVal: any;
    hours: number[];
    mins: number[];
    hour: number;
    min: number;
    constructor(el: ElementRef, da: DateAdapter<any>);
    ngOnInit(): void;
    castDefaultValue(defaultVal: any): any;
    applyValue(a?: any): void;
    supportedTemplates(): any[];
    static ɵfac: i0.ɵɵFactoryDeclaration<QuestionDateComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuestionDateComponent, "tou-date-question", never, { "showTime": "showTime"; "showDate": "showDate"; }, {}, never, never, false, never>;
}
export declare class QMAPExpressionLanguage {
    transform(template: any, question?: any): any;
    static ɵfac: i0.ɵɵFactoryDeclaration<QMAPExpressionLanguage, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<QMAPExpressionLanguage, "qmap_el", false>;
}
